#include "th_assert.h"
#include "Message_tags.h"
#include "Hate_primary.h"
#include "Replica.h"
#include "Principal.h"

Hate_primary::Hate_primary(View v) : 
#ifndef USE_PKEY
  Message(Hate_primary_tag, sizeof(Hate_primary_rep) + node->auth_size()) {
#else
  Message(Hate_primary_tag, sizeof(Hate_primary_rep) + node->sig_size()) {
#endif

    rep().v = v;
    rep().id = node->id();

// Kotla: Implement the multi-phase I_HATE_PRIMARY protocol
// to avoid public key cryptography
//#ifndef USE_PKEY
//   node->gen_auth_out(contents(), sizeof(Hate_primary_rep));
//#else
//    node->gen_signature(contents(), sizeof(Hate_primary_rep), contents()+sizeof(Hate_primary_rep));
//#endif

    node->gen_signature(contents(), sizeof(Hate_primary_rep), 
		      contents()+sizeof(Hate_primary_rep));
}

bool Hate_primary::verify() {
  // Hate_primarys must be sent by replicas.
  if (!node->is_replica(id())) return false;
  

// Kotla: Implement the multi-phase I_HATE_PRIMARY protocol
// to avoid public key cryptography
/*#ifndef USE_PKEY
  if (size()-(int)sizeof(Hate_primary_rep) < node->auth_size(id())) 
    return false;

  return node->verify_auth_in(id(), contents(), sizeof(Hate_primary_rep));
#else
  if (size()-(int)sizeof(Hate_primary_rep) < node->sig_size(id())) 
    return false;

  return node->i_to_p(id())->verify_signature(contents(), sizeof(Hate_primary_rep),
					      contents()+sizeof(Hate_primary_rep));
#endif
*/

// Check signature size.
  if (size()-(int)sizeof(Hate_primary_rep) < node->sig_size(id())) 
    return false;

  return node->i_to_p(id())->verify_signature(contents(), sizeof(Hate_primary_rep),
					      contents()+sizeof(Hate_primary_rep));
}

bool Hate_primary::convert(Message *m1, Hate_primary  *&m2) {
  if (!m1->has_tag(Hate_primary_tag, sizeof(Hate_primary_rep)))
    return false;
  m1->trim();
  m2 = (Hate_primary*)m1;
  return true;
}
