#ifndef _Prepared_cert_h
#define _Prepared_cert_h 1

#include <sys/time.h>
#include "types.h"
#include "Certificate.h"
#include "Node.h"

struct Auth_array {
  // Message
  // count
  // Mac list
}

class Order_cert {
public:
  
  Order_cert();
  // Effects: Creates an empty prepared certificate. 

  ~Order_cert();
  // Effects: Deletes certificate and all the messages it contains.
 
  bool add(Order_request *m);
  // Effects: Adds "m" to the certificate and returns true provided
  // "m" satisfies:
  // 1. there is no message from "m.id()" in the certificate
  // 2. "m->verify() == true"
  // otherwise, it has no effect on this and returns false.  This
  // becomes the owner of "m" (i.e., no other code should delete "m"
  // or retain pointers to "m".)

  Auth_array *collect_auth(int id);
  // Effects : Collects MACs signed for id by various replicas in the certificate
  
  bool verify_auth(Auth_array*, int threshold);
  
private:
  Certificate<Order_request> oc; 
  Auth_array *auth; // Store authenticators of the replicas
  Time t_sent; // time at which pp was sent (if I am primary)
  bool primary; // true iff pp was added with add_mine
};
