#include <stdlib.h>
#include <string.h>

#include "Rep_info.h"
#include "Replica.h"
#include "Reply.h"
#include "Req_queue.h"

#include "Statistics.h"
#include "State_defs.h"

#include "Array.t"

Rep_info::Rep_info(int n) : reps((Reply *)NULL,n) {
  th_assert(n != 0, "Invalid argument");
  nps = n;
}


Rep_info::~Rep_info() {
  for (int i=0; i < nps; i++) {
    if (reps[i] != NULL) delete reps[i];
  }
}

bool Rep_info::add(int pid, Reply *r) {
 if ((reps[pid] == NULL) || (reps[pid]->request_id() < r->request_id())) {
    // Delete old request
    if (reps[pid] != NULL) {
 	delete reps[pid];
    }
    reps[pid] = r;
    return true;
 }
 return false;
}

Request_id  Rep_info::req_id(int pid) {
 if ((reps[pid] != NULL)) { 
    return reps[pid]->request_id(); 
 }
 else {
    return 0; // ERROR CODE : Clients should start request ids > 0
 }
}
