#include <stdlib.h>
#include <string.h>

#include "Req_cache.h"
#include "Replica.h"
#include "Order_request.h"
#include "Req_queue.h"

#include "Statistics.h"
#include "State_defs.h"

#include "Array.t"

Req_cache::Req_cache(int n) : reps((Order_request *)NULL,n),rid((Request_id)0,n) {
  th_assert(n != 0, "Invalid argument");
  nps = n;
}


Req_cache::~Req_cache() {
}

bool Req_cache::add(int pid, Request_id id, Order_request *r) {
 if ((reps[pid] == NULL) || (rid[pid] < id)) {
    /* if (reps[pid] != NULL) {
      fprintf(stderr,"Overwriting to client id :%d old rid :%llu new rid :%llu \n", pid, 
             rid[pid], id);
    }
    else {
      fprintf(stderr,"Writing to client id :%d new :%llu \n", pid, id);
   } */
    reps[pid] = r;
    rid[pid] =id;
    return true;
 }
 return false;
}

Request_id  Req_cache::req_id(int pid) {
 if ((reps[pid] != NULL)) { 
    return rid[pid]; 
 }
 else {
    return 0; // ERROR CODE : Clients should start request ids > 0
 }
}
