#ifndef _State_h
#define _State_h 1


#include "th_assert.h"
#include "types.h"
class Replica;

class State {
public:

  State(Replica *replica, int num_objs,
	int (*gets)(int, char **),
	void (*puts)(int, int *, int *, char **),
	void (*shutdown_p)(FILE *o),
	void (*restart_p)(FILE *i)
	); 

  // Effects: creates an object that handles state digesting and
  // checkpointing. The state will consist of "num_objs" objects,
  // the abstraction function is "gets" and "puts" is one of its
  // inverses.  The procedures invoked before and after recovery to save
  // and restore extra state information are "shutdown_p" and "restart_p".

  ~State();
  // Effects: Deallocates all storage associated with state.


  // ZYZZYVA : TO DO 
  // STATE MANIPULATION
}; 
#endif
