#ifndef _parameters_h
#define _parameters_h 1

const int Max_num_replicas = 32;

// Interval in sequence space between "checkpoint" states, i.e.,
// states that are checkpointed and for which Checkpoint messages are
// sent.
// Kotla :
//const int checkpoint_interval = 1024;
const int checkpoint_interval = 128;

// Maximum number of messages for which protocol can be
// simultaneously in progress, i.e., messages with sequence number
// higher than last_stable+max_out are ignored. It is required that
// max_out > checkpoint_interval. Otherwise, the algorithm will be
// unable to make progress.

const int max_out = 1024; 

// Maximum number of outstanding view change instances 
const int max_view_changes = 128;

#define FULL_REPLY_BIT_SET 0x8000
#define FULL_REPLY_BIT_MASK 0xffff7fff

#endif // _parameters_h
