/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#ifndef _SFS_PROT_H_RPCGEN
#define _SFS_PROT_H_RPCGEN

#include "sfs-internal.h"

#include "bigint.h"
#include "nfs3_prot.h"
#define ex_NFS_PROGRAM 344444
#define ex_NFS_V3 3
#define SFS_PORT 4
#define SFS_RELEASE 7

enum sfsstat {
	SFS_OK = 0,
	SFS_BADLOGIN = 1,
	SFS_NOSUCHHOST = 2,
	SFS_NOTSUPP = 10004,
	SFS_TEMPERR = 10008,
	SFS_REDIRECT = 10020
};
typedef enum sfsstat sfsstat;
RPC_EXTERN bool_t xdr_sfsstat(XDR *, sfsstat *);

enum sfs_msgtype {
	SFS_NULL = 0,
	SFS_HOSTINFO = 1,
	SFS_KSC = 2,
	SFS_KCS = 3,
	SFS_SESSINFO = 4,
	SFS_AUTHINFO = 5,
	SFS_SIGNED_AUTHREQ = 6,
	SFS_AUTHREGISTER = 7,
	SFS_AUTHUPDATE = 8,
	SFS_PATHREVOKE = 9,
	SFS_KEYCERT = 10,
	SFS_ROFSINFO = 11,
	SFS_UPDATEREQ = 12,
	SFS_PUBKEY2_HASH = 13,
	SFS_SIGNED_AUTHREQ_NOCRED = 14
};
typedef enum sfs_msgtype sfs_msgtype;
RPC_EXTERN bool_t xdr_sfs_msgtype(XDR *, sfs_msgtype *);

enum sfs_service {
	SFS_SFS = 1,
	SFS_AUTHSERV = 2,
	SFS_REX = 3
};
typedef enum sfs_service sfs_service;
RPC_EXTERN bool_t xdr_sfs_service(XDR *, sfs_service *);

typedef char *sfs_extension;
RPC_EXTERN bool_t xdr_sfs_extension(XDR *, sfs_extension *);

typedef char *sfs_hostname;
RPC_EXTERN bool_t xdr_sfs_hostname(XDR *, sfs_hostname *);

typedef char *sfs_idname;
RPC_EXTERN bool_t xdr_sfs_idname(XDR *, sfs_idname *);

typedef char sfs_hash[20];
RPC_EXTERN bool_t xdr_sfs_hash(XDR *, sfs_hash);

typedef char sfs_secret[16];
RPC_EXTERN bool_t xdr_sfs_secret(XDR *, sfs_secret);

typedef u_longlong_t sfs_seqno;
RPC_EXTERN bool_t xdr_sfs_seqno(XDR *, sfs_seqno *);

typedef u_longlong_t sfs_time;
RPC_EXTERN bool_t xdr_sfs_time(XDR *, sfs_time *);

typedef bigint sfs_pubkey;
RPC_EXTERN bool_t xdr_sfs_pubkey(XDR *, sfs_pubkey *);

typedef bigint sfs_ctext;
RPC_EXTERN bool_t xdr_sfs_ctext(XDR *, sfs_ctext *);

typedef bigint sfs_sig;
RPC_EXTERN bool_t xdr_sfs_sig(XDR *, sfs_sig *);

enum sfs_keytype {
	SFS_NOKEY = 0,
	SFS_RABIN = 1,
	SFS_2SCHNORR = 2,
	SFS_SCHNORR = 3,
	SFS_1SCHNORR = 4
};
typedef enum sfs_keytype sfs_keytype;
RPC_EXTERN bool_t xdr_sfs_keytype(XDR *, sfs_keytype *);

typedef struct sfs_1schnorr_priv_xdr {
	bigint p;
	bigint q;
	bigint g;
	bigint y;
	bigint x;
} sfs_1schnorr_priv_xdr;
RPC_EXTERN bool_t xdr_sfs_1schnorr_priv_xdr(XDR *, sfs_1schnorr_priv_xdr *);
RPC_CONSTRUCT (Sfs_1schnorr_priv_xdr, sfs_1schnorr_priv_xdr)

typedef struct sfs_2schnorr_priv_xdr {
	bigint p;
	bigint q;
	bigint g;
	bigint y;
	bigint x;
	sfs_hostname hostname;
	sfs_idname uname;
	char *audit;
} sfs_2schnorr_priv_xdr;
RPC_EXTERN bool_t xdr_sfs_2schnorr_priv_xdr(XDR *, sfs_2schnorr_priv_xdr *);
RPC_CONSTRUCT (Sfs_2schnorr_priv_xdr, sfs_2schnorr_priv_xdr)

typedef struct sfs_2schnorr_priv_export {
	sfs_keytype kt;
	sfs_hash cksum;
	struct {
		u_int len;
		sfs_2schnorr_priv_xdr *val;
	} privkeys;
} sfs_2schnorr_priv_export;
RPC_EXTERN bool_t xdr_sfs_2schnorr_priv_export(XDR *, sfs_2schnorr_priv_export *);
RPC_CONSTRUCT (Sfs_2schnorr_priv_export, sfs_2schnorr_priv_export)

typedef struct sfs_1schnorr_priv_export {
	sfs_keytype kt;
	sfs_hash cksum;
	sfs_1schnorr_priv_xdr privkey;
} sfs_1schnorr_priv_export;
RPC_EXTERN bool_t xdr_sfs_1schnorr_priv_export(XDR *, sfs_1schnorr_priv_export *);
RPC_CONSTRUCT (Sfs_1schnorr_priv_export, sfs_1schnorr_priv_export)

typedef struct sfs_schnorr_pub_xdr {
	bigint p;
	bigint q;
	bigint g;
	bigint y;
} sfs_schnorr_pub_xdr;
RPC_EXTERN bool_t xdr_sfs_schnorr_pub_xdr(XDR *, sfs_schnorr_pub_xdr *);
RPC_CONSTRUCT (Sfs_schnorr_pub_xdr, sfs_schnorr_pub_xdr)

typedef struct sfs_schnorr_sig {
	bigint r;
	bigint s;
} sfs_schnorr_sig;
RPC_EXTERN bool_t xdr_sfs_schnorr_sig(XDR *, sfs_schnorr_sig *);
RPC_CONSTRUCT (Sfs_schnorr_sig, sfs_schnorr_sig)

typedef struct sfs_2schnorr_presig {
	bigint r;
} sfs_2schnorr_presig;
RPC_EXTERN bool_t xdr_sfs_2schnorr_presig(XDR *, sfs_2schnorr_presig *);
RPC_CONSTRUCT (Sfs_2schnorr_presig, sfs_2schnorr_presig)

typedef struct sfs_rabin_priv_export {
	bigint p;
	bigint q;
	sfs_hash cksum;
} sfs_rabin_priv_export;
RPC_EXTERN bool_t xdr_sfs_rabin_priv_export(XDR *, sfs_rabin_priv_export *);
RPC_CONSTRUCT (Sfs_rabin_priv_export, sfs_rabin_priv_export)

typedef struct sfs_rabin_priv_xdr {
	bigint p;
	bigint q;
} sfs_rabin_priv_xdr;
RPC_EXTERN bool_t xdr_sfs_rabin_priv_xdr(XDR *, sfs_rabin_priv_xdr *);
RPC_CONSTRUCT (Sfs_rabin_priv_xdr, sfs_rabin_priv_xdr)

typedef struct {
	u_int len;
	char *val;
} sfs_privkey2;
RPC_EXTERN bool_t xdr_sfs_privkey2(XDR *, sfs_privkey2 *);

typedef struct sfs_pubkey2 {
	sfs_keytype type;
	union {
		bigint rabin;
		sfs_schnorr_pub_xdr schnorr;
	} RPC_UNION_NAME(sfs_pubkey2);
} sfs_pubkey2;
RPC_EXTERN bool_t xdr_sfs_pubkey2(XDR *, sfs_pubkey2 *);
RPC_CONSTRUCT (Sfs_pubkey2, sfs_pubkey2)

typedef struct sfs_ctext2 {
	sfs_keytype type;
	union {
		bigint rabin;
	} RPC_UNION_NAME(sfs_ctext2);
} sfs_ctext2;
RPC_EXTERN bool_t xdr_sfs_ctext2(XDR *, sfs_ctext2 *);
RPC_CONSTRUCT (Sfs_ctext2, sfs_ctext2)

typedef struct sfs_sig2 {
	sfs_keytype type;
	union {
		bigint rabin;
		sfs_schnorr_sig schnorr;
	} RPC_UNION_NAME(sfs_sig2);
} sfs_sig2;
RPC_EXTERN bool_t xdr_sfs_sig2(XDR *, sfs_sig2 *);
RPC_CONSTRUCT (Sfs_sig2, sfs_sig2)

typedef struct sfs_hashcharge {
	u_int bitcost;
	sfs_hash target;
} sfs_hashcharge;
RPC_EXTERN bool_t xdr_sfs_hashcharge(XDR *, sfs_hashcharge *);
RPC_CONSTRUCT (Sfs_hashcharge, sfs_hashcharge)

typedef char sfs_hashpay[64];
RPC_EXTERN bool_t xdr_sfs_hashpay(XDR *, sfs_hashpay);

typedef struct sfs_hostinfo {
	sfs_msgtype type;
	sfs_hostname hostname;
	sfs_pubkey pubkey;
} sfs_hostinfo;
RPC_EXTERN bool_t xdr_sfs_hostinfo(XDR *, sfs_hostinfo *);
RPC_CONSTRUCT (Sfs_hostinfo, sfs_hostinfo)

typedef struct sfs_pubkey2_hash {
	sfs_msgtype type;
	sfs_pubkey2 pubkey;
} sfs_pubkey2_hash;
RPC_EXTERN bool_t xdr_sfs_pubkey2_hash(XDR *, sfs_pubkey2_hash *);
RPC_CONSTRUCT (Sfs_pubkey2_hash, sfs_pubkey2_hash)

typedef struct sfs_hostinfo2 {
	sfs_msgtype type;
	sfs_hostname hostname;
	u_int port;
	sfs_pubkey2 pubkey;
} sfs_hostinfo2;
RPC_EXTERN bool_t xdr_sfs_hostinfo2(XDR *, sfs_hostinfo2 *);
RPC_CONSTRUCT (Sfs_hostinfo2, sfs_hostinfo2)

typedef struct sfs_connectinfo_4 {
	sfs_service service;
	sfs_hostname name;
	sfs_hash hostid;
	struct {
		u_int len;
		sfs_extension *val;
	} extensions;
} sfs_connectinfo_4;
RPC_EXTERN bool_t xdr_sfs_connectinfo_4(XDR *, sfs_connectinfo_4 *);
RPC_CONSTRUCT (Sfs_connectinfo_4, sfs_connectinfo_4)

typedef struct sfs_connectinfo_5 {
	u_int release;
	sfs_service service;
	filename3 sname;
	struct {
		u_int len;
		sfs_extension *val;
	} extensions;
} sfs_connectinfo_5;
RPC_EXTERN bool_t xdr_sfs_connectinfo_5(XDR *, sfs_connectinfo_5 *);
RPC_CONSTRUCT (Sfs_connectinfo_5, sfs_connectinfo_5)

typedef struct sfs_connectinfo {
	u_int civers;
	union {
		sfs_connectinfo_4 ci4;
		sfs_connectinfo_5 ci5;
	} RPC_UNION_NAME(sfs_connectinfo);
} sfs_connectinfo;
RPC_EXTERN bool_t xdr_sfs_connectinfo(XDR *, sfs_connectinfo *);
RPC_CONSTRUCT (Sfs_connectinfo, sfs_connectinfo)

typedef struct sfs_servinfo_5 {
	sfs_hostinfo host;
	u_int prog;
	u_int vers;
} sfs_servinfo_5;
RPC_EXTERN bool_t xdr_sfs_servinfo_5(XDR *, sfs_servinfo_5 *);
RPC_CONSTRUCT (Sfs_servinfo_5, sfs_servinfo_5)

typedef struct sfs_servinfo_7 {
	u_int release;
	sfs_hostinfo2 host;
	u_int prog;
	u_int vers;
} sfs_servinfo_7;
RPC_EXTERN bool_t xdr_sfs_servinfo_7(XDR *, sfs_servinfo_7 *);
RPC_CONSTRUCT (Sfs_servinfo_7, sfs_servinfo_7)

typedef struct sfs_servinfo {
	u_int sivers;
	union {
		sfs_servinfo_5 cr5;
		sfs_servinfo_7 cr7;
	} RPC_UNION_NAME(sfs_servinfo);
} sfs_servinfo;
RPC_EXTERN bool_t xdr_sfs_servinfo(XDR *, sfs_servinfo *);
RPC_CONSTRUCT (Sfs_servinfo, sfs_servinfo)

typedef struct sfs_sesskeydat {
	sfs_msgtype type;
	sfs_servinfo si;
	sfs_secret sshare;
	sfs_connectinfo ci;
	sfs_pubkey kc;
	sfs_secret cshare;
} sfs_sesskeydat;
RPC_EXTERN bool_t xdr_sfs_sesskeydat(XDR *, sfs_sesskeydat *);
RPC_CONSTRUCT (Sfs_sesskeydat, sfs_sesskeydat)

typedef struct sfs_sessinfo {
	sfs_msgtype type;
	struct {
		u_int len;
		char *val;
	} ksc;
	struct {
		u_int len;
		char *val;
	} kcs;
} sfs_sessinfo;
RPC_EXTERN bool_t xdr_sfs_sessinfo(XDR *, sfs_sessinfo *);
RPC_CONSTRUCT (Sfs_sessinfo, sfs_sessinfo)

typedef struct sfs_authinfo {
	sfs_msgtype type;
	sfs_service service;
	sfs_hostname name;
	sfs_hash hostid;
	sfs_hash sessid;
} sfs_authinfo;
RPC_EXTERN bool_t xdr_sfs_authinfo(XDR *, sfs_authinfo *);
RPC_CONSTRUCT (Sfs_authinfo, sfs_authinfo)

typedef struct sfs_kmsg {
	sfs_secret kcs_share;
	sfs_secret ksc_share;
} sfs_kmsg;
RPC_EXTERN bool_t xdr_sfs_kmsg(XDR *, sfs_kmsg *);
RPC_CONSTRUCT (Sfs_kmsg, sfs_kmsg)

typedef struct sfs_keycert_msg {
	sfs_msgtype type;
	u_int duration;
	sfs_time start;
	sfs_pubkey key;
} sfs_keycert_msg;
RPC_EXTERN bool_t xdr_sfs_keycert_msg(XDR *, sfs_keycert_msg *);
RPC_CONSTRUCT (Sfs_keycert_msg, sfs_keycert_msg)

typedef struct sfs_keycert {
	sfs_keycert_msg msg;
	sfs_sig sig;
} sfs_keycert;
RPC_EXTERN bool_t xdr_sfs_keycert(XDR *, sfs_keycert *);
RPC_CONSTRUCT (Sfs_keycert, sfs_keycert)

typedef struct sfs_signed_authreq {
	sfs_msgtype type;
	sfs_hash authid;
	sfs_seqno seqno;
	char usrinfo[16];
} sfs_signed_authreq;
RPC_EXTERN bool_t xdr_sfs_signed_authreq(XDR *, sfs_signed_authreq *);
RPC_CONSTRUCT (Sfs_signed_authreq, sfs_signed_authreq)

typedef struct sfs_redirect {
	sfs_time serial;
	sfs_time expire;
	sfs_hostinfo2 hostinfo;
} sfs_redirect;
RPC_EXTERN bool_t xdr_sfs_redirect(XDR *, sfs_redirect *);
RPC_CONSTRUCT (Sfs_redirect, sfs_redirect)

typedef struct sfs_pathrevoke_msg {
	sfs_msgtype type;
	sfs_hostinfo2 path;
	sfs_redirect *redirect;
} sfs_pathrevoke_msg;
RPC_EXTERN bool_t xdr_sfs_pathrevoke_msg(XDR *, sfs_pathrevoke_msg *);
RPC_CONSTRUCT (Sfs_pathrevoke_msg, sfs_pathrevoke_msg)

typedef struct sfs_pathrevoke {
	sfs_pathrevoke_msg msg;
	sfs_sig2 sig;
} sfs_pathrevoke;
RPC_EXTERN bool_t xdr_sfs_pathrevoke(XDR *, sfs_pathrevoke *);
RPC_CONSTRUCT (Sfs_pathrevoke, sfs_pathrevoke)

typedef sfs_connectinfo sfs_connectarg;
RPC_EXTERN bool_t xdr_sfs_connectarg(XDR *, sfs_connectarg *);

typedef struct sfs_connectok {
	sfs_servinfo servinfo;
	sfs_hashcharge charge;
} sfs_connectok;
RPC_EXTERN bool_t xdr_sfs_connectok(XDR *, sfs_connectok *);
RPC_CONSTRUCT (Sfs_connectok, sfs_connectok)

typedef struct sfs_connectres {
	sfsstat status;
	union {
		sfs_connectok reply;
		sfs_pathrevoke revoke;
	} RPC_UNION_NAME(sfs_connectres);
} sfs_connectres;
RPC_EXTERN bool_t xdr_sfs_connectres(XDR *, sfs_connectres *);
RPC_CONSTRUCT (Sfs_connectres, sfs_connectres)

typedef struct sfs_encryptarg {
	sfs_hashpay payment;
	sfs_ctext kmsg;
	sfs_pubkey pubkey;
} sfs_encryptarg;
RPC_EXTERN bool_t xdr_sfs_encryptarg(XDR *, sfs_encryptarg *);
RPC_CONSTRUCT (Sfs_encryptarg, sfs_encryptarg)

typedef struct sfs_encryptarg2 {
	sfs_hashpay payment;
	sfs_ctext2 kmsg;
	sfs_pubkey2 pubkey;
} sfs_encryptarg2;
RPC_EXTERN bool_t xdr_sfs_encryptarg2(XDR *, sfs_encryptarg2 *);
RPC_CONSTRUCT (Sfs_encryptarg2, sfs_encryptarg2)

typedef sfs_ctext sfs_encryptres;
RPC_EXTERN bool_t xdr_sfs_encryptres(XDR *, sfs_encryptres *);

typedef sfs_ctext2 sfs_encryptres2;
RPC_EXTERN bool_t xdr_sfs_encryptres2(XDR *, sfs_encryptres2 *);

typedef struct sfs_nfs3_subfs {
	nfspath3 path;
	nfs_fh3 fh;
} sfs_nfs3_subfs;
RPC_EXTERN bool_t xdr_sfs_nfs3_subfs(XDR *, sfs_nfs3_subfs *);
RPC_CONSTRUCT (Sfs_nfs3_subfs, sfs_nfs3_subfs)

typedef struct sfs_nfs3_fsinfo {
	nfs_fh3 root;
	struct {
		u_int len;
		sfs_nfs3_subfs *val;
	} subfs;
} sfs_nfs3_fsinfo;
RPC_EXTERN bool_t xdr_sfs_nfs3_fsinfo(XDR *, sfs_nfs3_fsinfo *);
RPC_CONSTRUCT (Sfs_nfs3_fsinfo, sfs_nfs3_fsinfo)

typedef struct sfs_nfs_fsinfo {
	int vers;
	union {
		sfs_nfs3_fsinfo v3;
	} RPC_UNION_NAME(sfs_nfs_fsinfo);
} sfs_nfs_fsinfo;
RPC_EXTERN bool_t xdr_sfs_nfs_fsinfo(XDR *, sfs_nfs_fsinfo *);
RPC_CONSTRUCT (Sfs_nfs_fsinfo, sfs_nfs_fsinfo)

typedef struct sfs_fsinfo {
	int prog;
	union {
		sfs_nfs_fsinfo nfs;
	} RPC_UNION_NAME(sfs_fsinfo);
} sfs_fsinfo;
RPC_EXTERN bool_t xdr_sfs_fsinfo(XDR *, sfs_fsinfo *);
RPC_CONSTRUCT (Sfs_fsinfo, sfs_fsinfo)

typedef struct sfs_opt_idname {
	bool_t present;
	union {
		sfs_idname name;
	} RPC_UNION_NAME(sfs_opt_idname);
} sfs_opt_idname;
RPC_EXTERN bool_t xdr_sfs_opt_idname(XDR *, sfs_opt_idname *);
RPC_CONSTRUCT (Sfs_opt_idname, sfs_opt_idname)

typedef struct sfs_idnums {
	int uid;
	int gid;
} sfs_idnums;
RPC_EXTERN bool_t xdr_sfs_idnums(XDR *, sfs_idnums *);
RPC_CONSTRUCT (Sfs_idnums, sfs_idnums)

typedef struct sfs_idnames {
	sfs_opt_idname uidname;
	sfs_opt_idname gidname;
} sfs_idnames;
RPC_EXTERN bool_t xdr_sfs_idnames(XDR *, sfs_idnames *);
RPC_CONSTRUCT (Sfs_idnames, sfs_idnames)

enum sfs_loginstat {
	SFSLOGIN_OK = 0,
	SFSLOGIN_MORE = 1,
	SFSLOGIN_BAD = 2,
	SFSLOGIN_ALLBAD = 3,
	SFSLOGIN_AGAIN = 4
};
typedef enum sfs_loginstat sfs_loginstat;
RPC_EXTERN bool_t xdr_sfs_loginstat(XDR *, sfs_loginstat *);

typedef struct sfs_loginres {
	sfs_loginstat status;
	union {
		u_int authno;
		struct {
			u_int len;
			char *val;
		} resmore;
	} RPC_UNION_NAME(sfs_loginres);
} sfs_loginres;
RPC_EXTERN bool_t xdr_sfs_loginres(XDR *, sfs_loginres *);
RPC_CONSTRUCT (Sfs_loginres, sfs_loginres)

typedef struct sfs_loginarg {
	sfs_seqno seqno;
	struct {
		u_int len;
		char *val;
	} certificate;
} sfs_loginarg;
RPC_EXTERN bool_t xdr_sfs_loginarg(XDR *, sfs_loginarg *);
RPC_CONSTRUCT (Sfs_loginarg, sfs_loginarg)

enum sfsauth_stat {
	SFSAUTH_OK = 0,
	SFSAUTH_LOGINMORE = 1,
	SFSAUTH_FAILED = 2,
	SFSAUTH_LOGINALLBAD = 3,
	SFSAUTH_NOTSOCK = 4,
	SFSAUTH_BADUSERNAME = 5,
	SFSAUTH_WRONGUID = 6,
	SFSAUTH_DENYROOT = 7,
	SFSAUTH_BADSHELL = 8,
	SFSAUTH_DENYFILE = 9,
	SFSAUTH_BADPASSWORD = 10,
	SFSAUTH_USEREXISTS = 11,
	SFSAUTH_NOCHANGES = 12,
	SFSAUTH_NOSRP = 13,
	SFSAUTH_BADSIGNATURE = 14,
	SFSAUTH_PROTOERR = 15,
	SFSAUTH_NOTTHERE = 16,
	SFSAUTH_BADAUTHID = 17,
	SFSAUTH_KEYEXISTS = 18,
	SFSAUTH_BADKEYNAME = 19
};
typedef enum sfsauth_stat sfsauth_stat;
RPC_EXTERN bool_t xdr_sfsauth_stat(XDR *, sfsauth_stat *);

enum sfs_authtype {
	SFS_NOAUTH = 0,
	SFS_AUTHREQ = 1,
	SFS_AUTHREQ2 = 2,
	SFS_SRPAUTH = 3,
	SFS_UNIXPWAUTH = 4
};
typedef enum sfs_authtype sfs_authtype;
RPC_EXTERN bool_t xdr_sfs_authtype(XDR *, sfs_authtype *);

typedef struct sfs_authreq {
	sfs_pubkey usrkey;
	sfs_sig signed_req;
} sfs_authreq;
RPC_EXTERN bool_t xdr_sfs_authreq(XDR *, sfs_authreq *);
RPC_CONSTRUCT (Sfs_authreq, sfs_authreq)

typedef struct sfs_autharg {
	sfs_authtype type;
	union {
		sfs_authreq req;
	} RPC_UNION_NAME(sfs_autharg);
} sfs_autharg;
RPC_EXTERN bool_t xdr_sfs_autharg(XDR *, sfs_autharg *);
RPC_CONSTRUCT (Sfs_autharg, sfs_autharg)

enum sfs_credtype {
	SFS_NOCRED = 0,
	SFS_UNIXCRED = 1,
	SFS_PKCRED = 2
};
typedef enum sfs_credtype sfs_credtype;
RPC_EXTERN bool_t xdr_sfs_credtype(XDR *, sfs_credtype *);

typedef struct sfs_unixcred {
	char *username;
	char *homedir;
	char *shell;
	u_int uid;
	u_int gid;
	struct {
		u_int len;
		u_int *val;
	} groups;
} sfs_unixcred;
RPC_EXTERN bool_t xdr_sfs_unixcred(XDR *, sfs_unixcred *);
RPC_CONSTRUCT (Sfs_unixcred, sfs_unixcred)

typedef struct sfsauth_cred {
	sfs_credtype type;
	union {
		sfs_unixcred unixcred;
		char *pkhash;
	} RPC_UNION_NAME(sfsauth_cred);
} sfsauth_cred;
RPC_EXTERN bool_t xdr_sfsauth_cred(XDR *, sfsauth_cred *);
RPC_CONSTRUCT (Sfsauth_cred, sfsauth_cred)

typedef struct sfsauth_loginokres {
	sfsauth_cred cred;
	sfs_hash authid;
	sfs_seqno seqno;
} sfsauth_loginokres;
RPC_EXTERN bool_t xdr_sfsauth_loginokres(XDR *, sfsauth_loginokres *);
RPC_CONSTRUCT (Sfsauth_loginokres, sfsauth_loginokres)

typedef struct sfsauth_loginres {
	sfs_loginstat status;
	union {
		sfsauth_loginokres resok;
		struct {
			u_int len;
			char *val;
		} resmore;
	} RPC_UNION_NAME(sfsauth_loginres);
} sfsauth_loginres;
RPC_EXTERN bool_t xdr_sfsauth_loginres(XDR *, sfsauth_loginres *);
RPC_CONSTRUCT (Sfsauth_loginres, sfsauth_loginres)

typedef struct sfssrp_parms {
	bigint N;
	bigint g;
} sfssrp_parms;
RPC_EXTERN bool_t xdr_sfssrp_parms(XDR *, sfssrp_parms *);
RPC_CONSTRUCT (Sfssrp_parms, sfssrp_parms)

typedef struct sfsauth_srpparmsres {
	sfsauth_stat status;
	union {
		sfssrp_parms parms;
	} RPC_UNION_NAME(sfsauth_srpparmsres);
} sfsauth_srpparmsres;
RPC_EXTERN bool_t xdr_sfsauth_srpparmsres(XDR *, sfsauth_srpparmsres *);
RPC_CONSTRUCT (Sfsauth_srpparmsres, sfsauth_srpparmsres)

typedef struct {
	u_int len;
	char *val;
} sfssrp_bytes;
RPC_EXTERN bool_t xdr_sfssrp_bytes(XDR *, sfssrp_bytes *);

typedef struct sfssrp_init_arg {
	char *username;
	sfssrp_bytes msg;
} sfssrp_init_arg;
RPC_EXTERN bool_t xdr_sfssrp_init_arg(XDR *, sfssrp_init_arg *);
RPC_CONSTRUCT (Sfssrp_init_arg, sfssrp_init_arg)

typedef struct sfsauth_srpres {
	sfsauth_stat status;
	union {
		sfssrp_bytes msg;
	} RPC_UNION_NAME(sfsauth_srpres);
} sfsauth_srpres;
RPC_EXTERN bool_t xdr_sfsauth_srpres(XDR *, sfsauth_srpres *);
RPC_CONSTRUCT (Sfsauth_srpres, sfsauth_srpres)

typedef struct sfsauth_fetchresok {
	char *privkey;
	sfs_hash hostid;
} sfsauth_fetchresok;
RPC_EXTERN bool_t xdr_sfsauth_fetchresok(XDR *, sfsauth_fetchresok *);
RPC_CONSTRUCT (Sfsauth_fetchresok, sfsauth_fetchresok)

typedef struct sfsauth_fetchres {
	sfsauth_stat status;
	union {
		sfsauth_fetchresok resok;
	} RPC_UNION_NAME(sfsauth_fetchres);
} sfsauth_fetchres;
RPC_EXTERN bool_t xdr_sfsauth_fetchres(XDR *, sfsauth_fetchres *);
RPC_CONSTRUCT (Sfsauth_fetchres, sfsauth_fetchres)

typedef char *sfsauth_realm;
RPC_EXTERN bool_t xdr_sfsauth_realm(XDR *, sfsauth_realm *);

typedef char *sfsauth_certpath;
RPC_EXTERN bool_t xdr_sfsauth_certpath(XDR *, sfsauth_certpath *);

typedef struct {
	u_int len;
	sfsauth_certpath *val;
} sfsauth_certpaths;
RPC_EXTERN bool_t xdr_sfsauth_certpaths(XDR *, sfsauth_certpaths *);

enum sfs_certstat {
	SFSAUTH_CERT_SELF = 0,
	SFSAUTH_CERT_REALM = 1
};
typedef enum sfs_certstat sfs_certstat;
RPC_EXTERN bool_t xdr_sfs_certstat(XDR *, sfs_certstat *);

typedef struct sfsauth_certinfo_info {
	sfs_certstat status;
	union {
		sfsauth_certpaths certpaths;
	} RPC_UNION_NAME(sfsauth_certinfo_info);
} sfsauth_certinfo_info;
RPC_EXTERN bool_t xdr_sfsauth_certinfo_info(XDR *, sfsauth_certinfo_info *);
RPC_CONSTRUCT (Sfsauth_certinfo_info, sfsauth_certinfo_info)

typedef struct sfsauth_certinfores {
	sfsauth_realm name;
	sfsauth_certinfo_info info;
} sfsauth_certinfores;
RPC_EXTERN bool_t xdr_sfsauth_certinfores(XDR *, sfsauth_certinfores *);
RPC_CONSTRUCT (Sfsauth_certinfores, sfsauth_certinfores)

typedef struct sfsauth_srpinfo {
	char *info;
	char *privkey;
} sfsauth_srpinfo;
RPC_EXTERN bool_t xdr_sfsauth_srpinfo(XDR *, sfsauth_srpinfo *);
RPC_CONSTRUCT (Sfsauth_srpinfo, sfsauth_srpinfo)

typedef struct sfsauth_registermsg {
	sfs_msgtype type;
	char *username;
	char *password;
	sfs_pubkey pubkey;
	sfsauth_srpinfo *srpinfo;
} sfsauth_registermsg;
RPC_EXTERN bool_t xdr_sfsauth_registermsg(XDR *, sfsauth_registermsg *);
RPC_CONSTRUCT (Sfsauth_registermsg, sfsauth_registermsg)

typedef struct sfsauth_registerarg {
	sfsauth_registermsg msg;
	sfs_sig sig;
} sfsauth_registerarg;
RPC_EXTERN bool_t xdr_sfsauth_registerarg(XDR *, sfsauth_registerarg *);
RPC_CONSTRUCT (Sfsauth_registerarg, sfsauth_registerarg)

enum sfsauth_registerres {
	SFSAUTH_REGISTER_OK = 0,
	SFSAUTH_REGISTER_NOTSOCK = 1,
	SFSAUTH_REGISTER_BADUSERNAME = 2,
	SFSAUTH_REGISTER_WRONGUID = 3,
	SFSAUTH_REGISTER_DENYROOT = 4,
	SFSAUTH_REGISTER_BADSHELL = 5,
	SFSAUTH_REGISTER_DENYFILE = 6,
	SFSAUTH_REGISTER_BADPASSWORD = 7,
	SFSAUTH_REGISTER_USEREXISTS = 8,
	SFSAUTH_REGISTER_FAILED = 9,
	SFSAUTH_REGISTER_NOCHANGES = 10,
	SFSAUTH_REGISTER_NOSRP = 11,
	SFSAUTH_REGISTER_BADSIG = 12
};
typedef enum sfsauth_registerres sfsauth_registerres;
RPC_EXTERN bool_t xdr_sfsauth_registerres(XDR *, sfsauth_registerres *);

typedef struct sfsauth_updatemsg {
	sfs_msgtype type;
	sfs_hash authid;
	sfs_pubkey oldkey;
	sfs_pubkey newkey;
	sfsauth_srpinfo *srpinfo;
} sfsauth_updatemsg;
RPC_EXTERN bool_t xdr_sfsauth_updatemsg(XDR *, sfsauth_updatemsg *);
RPC_CONSTRUCT (Sfsauth_updatemsg, sfsauth_updatemsg)

typedef struct sfsauth_updatearg {
	sfsauth_updatemsg msg;
	sfs_sig osig;
	sfs_sig nsig;
} sfsauth_updatearg;
RPC_EXTERN bool_t xdr_sfsauth_updatearg(XDR *, sfsauth_updatearg *);
RPC_CONSTRUCT (Sfsauth_updatearg, sfsauth_updatearg)

#define SFS_PROGRAM ((u_long)344440)
RPC_EXTERN const struct rpcgen_table sfs_program_1_table[];
RPC_EXTERN const int sfs_program_1_nproc;
RPC_EXTERN const struct rpc_program  sfs_program_1;
#define SFS_VERSION ((u_long)1)
#define SFSPROC_NULL ((u_long)0)
#define SFSPROC_CONNECT ((u_long)1)
#define SFSPROC_ENCRYPT ((u_long)2)
#define SFSPROC_GETFSINFO ((u_long)3)
#define SFSPROC_LOGIN ((u_long)4)
#define SFSPROC_LOGOUT ((u_long)5)
#define SFSPROC_IDNAMES ((u_long)6)
#define SFSPROC_IDNUMS ((u_long)7)
#define SFSPROC_GETCRED ((u_long)8)
#define SFSPROC_ENCRYPT2 ((u_long)9)

#define SFSCB_PROGRAM ((u_long)344441)
RPC_EXTERN const struct rpcgen_table sfscb_program_1_table[];
RPC_EXTERN const int sfscb_program_1_nproc;
RPC_EXTERN const struct rpc_program  sfscb_program_1;
#define SFSCB_VERSION ((u_long)1)
#define SFSCBPROC_NULL ((u_long)0)

#define SFSAUTH_PROGRAM ((u_long)344442)
RPC_EXTERN const struct rpcgen_table sfsauth_program_1_table[];
RPC_EXTERN const int sfsauth_program_1_nproc;
RPC_EXTERN const struct rpc_program  sfsauth_program_1;
#define SFSAUTH_VERSION ((u_long)1)
#define SFSAUTHPROC_NULL ((u_long)0)
#define SFSAUTHPROC_LOGIN ((u_long)1)
#define SFSAUTHPROC_REGISTER ((u_long)2)
#define SFSAUTHPROC_UPDATE ((u_long)3)
#define SFSAUTHPROC_SRP_GETPARAMS ((u_long)4)
#define SFSAUTHPROC_SRP_INIT ((u_long)5)
#define SFSAUTHPROC_SRP_MORE ((u_long)6)
#define SFSAUTHPROC_FETCH ((u_long)7)
#define SFSAUTHPROC_CERTINFO ((u_long)8)


#endif /* !_SFS_PROT_H_RPCGEN */
