/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#ifndef _SFSAGENT_H_RPCGEN
#define _SFSAGENT_H_RPCGEN

#include "sfs-internal.h"

#include "sfs_prot.h"

typedef char *sfs_filename;
RPC_EXTERN bool_t xdr_sfs_filename(XDR *, sfs_filename *);

typedef struct sfsagent_authinit_arg {
	int ntries;
	char *requestor;
	sfs_authinfo authinfo;
	sfs_seqno seqno;
} sfsagent_authinit_arg;
RPC_EXTERN bool_t xdr_sfsagent_authinit_arg(XDR *, sfsagent_authinit_arg *);
RPC_CONSTRUCT (Sfsagent_authinit_arg, sfsagent_authinit_arg)

typedef struct sfsagent_auth_idtag {
	sfs_authinfo authinfo;
	sfs_seqno seqno;
} sfsagent_auth_idtag;
RPC_EXTERN bool_t xdr_sfsagent_auth_idtag(XDR *, sfsagent_auth_idtag *);
RPC_CONSTRUCT (Sfsagent_auth_idtag, sfsagent_auth_idtag)

typedef struct sfsagent_authmore_arg {
	sfs_authinfo authinfo;
	sfs_seqno seqno;
	struct {
		u_int len;
		char *val;
	} challenge;
} sfsagent_authmore_arg;
RPC_EXTERN bool_t xdr_sfsagent_authmore_arg(XDR *, sfsagent_authmore_arg *);
RPC_CONSTRUCT (Sfsagent_authmore_arg, sfsagent_authmore_arg)

typedef struct sfsagent_auth_res {
	bool_t authenticate;
	union {
		struct {
			u_int len;
			char *val;
		} certificate;
	} RPC_UNION_NAME(sfsagent_auth_res);
} sfsagent_auth_res;
RPC_EXTERN bool_t xdr_sfsagent_auth_res(XDR *, sfsagent_auth_res *);
RPC_CONSTRUCT (Sfsagent_auth_res, sfsagent_auth_res)

typedef char *sfsagent_path;
RPC_EXTERN bool_t xdr_sfsagent_path(XDR *, sfsagent_path *);

enum sfsagent_lookup_type {
	LOOKUP_NOOP = 0,
	LOOKUP_MAKELINK = 1,
	LOOKUP_MAKEDIR = 2
};
typedef enum sfsagent_lookup_type sfsagent_lookup_type;
RPC_EXTERN bool_t xdr_sfsagent_lookup_type(XDR *, sfsagent_lookup_type *);

typedef struct sfsagent_lookup_res {
	sfsagent_lookup_type type;
	union {
		sfsagent_path path;
		sfsagent_path dir;
	} RPC_UNION_NAME(sfsagent_lookup_res);
} sfsagent_lookup_res;
RPC_EXTERN bool_t xdr_sfsagent_lookup_res(XDR *, sfsagent_lookup_res *);
RPC_CONSTRUCT (Sfsagent_lookup_res, sfsagent_lookup_res)

enum sfs_revocation_type {
	REVOCATION_NONE = 0,
	REVOCATION_BLOCK = 1,
	REVOCATION_CERT = 2
};
typedef enum sfs_revocation_type sfs_revocation_type;
RPC_EXTERN bool_t xdr_sfs_revocation_type(XDR *, sfs_revocation_type *);

typedef struct sfsagent_revoked_res {
	sfs_revocation_type type;
	union {
		sfs_pathrevoke cert;
	} RPC_UNION_NAME(sfsagent_revoked_res);
} sfsagent_revoked_res;
RPC_EXTERN bool_t xdr_sfsagent_revoked_res(XDR *, sfsagent_revoked_res *);
RPC_CONSTRUCT (Sfsagent_revoked_res, sfsagent_revoked_res)

typedef struct sfsagent_symlink_arg {
	sfs_filename name;
	sfsagent_path contents;
} sfsagent_symlink_arg;
RPC_EXTERN bool_t xdr_sfsagent_symlink_arg(XDR *, sfsagent_symlink_arg *);
RPC_CONSTRUCT (Sfsagent_symlink_arg, sfsagent_symlink_arg)

typedef char sfsagent_seed[48];
RPC_EXTERN bool_t xdr_sfsagent_seed(XDR *, sfsagent_seed);
#define sfs_badgid -1

typedef struct sfs_privkey2_clear {
	sfs_keytype type;
	union {
		sfs_rabin_priv_xdr rabin;
		sfs_1schnorr_priv_xdr schnorr1;
		sfs_2schnorr_priv_xdr schnorr2;
	} RPC_UNION_NAME(sfs_privkey2_clear);
} sfs_privkey2_clear;
RPC_EXTERN bool_t xdr_sfs_privkey2_clear(XDR *, sfs_privkey2_clear *);
RPC_CONSTRUCT (Sfs_privkey2_clear, sfs_privkey2_clear)

typedef char *sfsagent_comment;
RPC_EXTERN bool_t xdr_sfsagent_comment(XDR *, sfsagent_comment *);

typedef struct sfs_addkey_arg {
	sfs_privkey2_clear privkey;
	int key_version;
	sfs_time expire;
	sfsagent_comment name;
} sfs_addkey_arg;
RPC_EXTERN bool_t xdr_sfs_addkey_arg(XDR *, sfs_addkey_arg *);
RPC_CONSTRUCT (Sfs_addkey_arg, sfs_addkey_arg)

typedef struct sfsagent_addextauth_arg {
	sfs_time expire;
	int pid;
	sfsagent_comment name;
} sfsagent_addextauth_arg;
RPC_EXTERN bool_t xdr_sfsagent_addextauth_arg(XDR *, sfsagent_addextauth_arg *);
RPC_CONSTRUCT (Sfsagent_addextauth_arg, sfsagent_addextauth_arg)

typedef struct sfsextauth_init {
	sfsagent_comment name;
	sfsagent_authinit_arg autharg;
} sfsextauth_init;
RPC_EXTERN bool_t xdr_sfsextauth_init(XDR *, sfsextauth_init *);
RPC_CONSTRUCT (Sfsextauth_init, sfsextauth_init)

typedef struct sfsextauth_more {
	sfsagent_comment name;
	sfsagent_authmore_arg autharg;
} sfsextauth_more;
RPC_EXTERN bool_t xdr_sfsextauth_more(XDR *, sfsextauth_more *);
RPC_CONSTRUCT (Sfsextauth_more, sfsextauth_more)

enum sfs_remauth_type {
	SFS_REM_PUBKEY = 0,
	SFS_REM_NAME = 1,
	SFS_REM_PID = 2
};
typedef enum sfs_remauth_type sfs_remauth_type;
RPC_EXTERN bool_t xdr_sfs_remauth_type(XDR *, sfs_remauth_type *);

typedef struct sfs_remauth_arg {
	sfs_remauth_type type;
	union {
		sfs_pubkey2 pubkey;
		sfsagent_comment name;
		int pid;
	} RPC_UNION_NAME(sfs_remauth_arg);
} sfs_remauth_arg;
RPC_EXTERN bool_t xdr_sfs_remauth_arg(XDR *, sfs_remauth_arg *);
RPC_CONSTRUCT (Sfs_remauth_arg, sfs_remauth_arg)

typedef struct sfs_keylistelm {
	char *desc;
	sfs_time expire;
	sfsagent_comment name;
	struct sfs_keylistelm *next;
} sfs_keylistelm;
RPC_EXTERN bool_t xdr_sfs_keylistelm(XDR *, sfs_keylistelm *);
RPC_CONSTRUCT (Sfs_keylistelm, sfs_keylistelm)

typedef sfs_keylistelm *sfs_keylist;
RPC_EXTERN bool_t xdr_sfs_keylist(XDR *, sfs_keylist *);

typedef char *sfsagent_progarg;
RPC_EXTERN bool_t xdr_sfsagent_progarg(XDR *, sfsagent_progarg *);

typedef struct {
	u_int len;
	sfsagent_progarg *val;
} sfsagent_cmd;
RPC_EXTERN bool_t xdr_sfsagent_cmd(XDR *, sfsagent_cmd *);

typedef struct sfsagent_certprog {
	char *prefix;
	char *filter;
	char *exclude;
	sfsagent_cmd av;
} sfsagent_certprog;
RPC_EXTERN bool_t xdr_sfsagent_certprog(XDR *, sfsagent_certprog *);
RPC_CONSTRUCT (Sfsagent_certprog, sfsagent_certprog)

typedef struct {
	u_int len;
	sfsagent_certprog *val;
} sfsagent_certprogs;
RPC_EXTERN bool_t xdr_sfsagent_certprogs(XDR *, sfsagent_certprogs *);

typedef struct sfsagent_blockfilter {
	char *filter;
	char *exclude;
} sfsagent_blockfilter;
RPC_EXTERN bool_t xdr_sfsagent_blockfilter(XDR *, sfsagent_blockfilter *);
RPC_CONSTRUCT (Sfsagent_blockfilter, sfsagent_blockfilter)

typedef struct sfsagent_revokeprog {
	sfsagent_blockfilter *block;
	sfsagent_cmd av;
} sfsagent_revokeprog;
RPC_EXTERN bool_t xdr_sfsagent_revokeprog(XDR *, sfsagent_revokeprog *);
RPC_CONSTRUCT (Sfsagent_revokeprog, sfsagent_revokeprog)

typedef struct {
	u_int len;
	sfsagent_revokeprog *val;
} sfsagent_revokeprogs;
RPC_EXTERN bool_t xdr_sfsagent_revokeprogs(XDR *, sfsagent_revokeprogs *);

typedef struct {
	u_int len;
	sfs_hash *val;
} sfsagent_norevoke_list;
RPC_EXTERN bool_t xdr_sfsagent_norevoke_list(XDR *, sfsagent_norevoke_list *);

typedef char *sfsagent_srpname;
RPC_EXTERN bool_t xdr_sfsagent_srpname(XDR *, sfsagent_srpname *);

typedef struct sfsagent_srpname_pair {
	sfsagent_srpname srpname;
	sfs_hostname sfsname;
} sfsagent_srpname_pair;
RPC_EXTERN bool_t xdr_sfsagent_srpname_pair(XDR *, sfsagent_srpname_pair *);
RPC_CONSTRUCT (Sfsagent_srpname_pair, sfsagent_srpname_pair)

typedef struct {
	u_int len;
	sfsagent_srpname_pair *val;
} sfsagent_srpname_pairs;
RPC_EXTERN bool_t xdr_sfsagent_srpname_pairs(XDR *, sfsagent_srpname_pairs *);

typedef struct sfsagent_srpname_res {
	bool_t status;
	union {
		sfs_hostname sfsname;
	} RPC_UNION_NAME(sfsagent_srpname_res);
} sfsagent_srpname_res;
RPC_EXTERN bool_t xdr_sfsagent_srpname_res(XDR *, sfsagent_srpname_res *);
RPC_CONSTRUCT (Sfsagent_srpname_res, sfsagent_srpname_res)

typedef struct sfsagent_rex_arg {
	sfs_hostname dest;
	bool_t forwardagent;
} sfsagent_rex_arg;
RPC_EXTERN bool_t xdr_sfsagent_rex_arg(XDR *, sfsagent_rex_arg *);
RPC_CONSTRUCT (Sfsagent_rex_arg, sfsagent_rex_arg)

typedef struct sfsagent_rex_resok {
	sfs_kmsg kcs;
	sfs_kmsg ksc;
	sfs_seqno seqno;
} sfsagent_rex_resok;
RPC_EXTERN bool_t xdr_sfsagent_rex_resok(XDR *, sfsagent_rex_resok *);
RPC_CONSTRUCT (Sfsagent_rex_resok, sfsagent_rex_resok)

typedef struct sfsagent_rex_res {
	bool_t status;
	union {
		sfsagent_rex_resok resok;
	} RPC_UNION_NAME(sfsagent_rex_res);
} sfsagent_rex_res;
RPC_EXTERN bool_t xdr_sfsagent_rex_res(XDR *, sfsagent_rex_res *);
RPC_CONSTRUCT (Sfsagent_rex_res, sfsagent_rex_res)

typedef struct rex_sessentry {
	sfs_hostname to;
	sfs_hostname created_from;
	bool_t agentforwarded;
} rex_sessentry;
RPC_EXTERN bool_t xdr_rex_sessentry(XDR *, rex_sessentry *);
RPC_CONSTRUCT (Rex_sessentry, rex_sessentry)

typedef struct {
	u_int len;
	rex_sessentry *val;
} rex_sessvec;
RPC_EXTERN bool_t xdr_rex_sessvec(XDR *, rex_sessvec *);

typedef struct sfsctl_getfh_arg {
	filename3 filesys;
	u_int64_t fileid;
} sfsctl_getfh_arg;
RPC_EXTERN bool_t xdr_sfsctl_getfh_arg(XDR *, sfsctl_getfh_arg *);
RPC_CONSTRUCT (Sfsctl_getfh_arg, sfsctl_getfh_arg)

typedef struct sfsctl_getfh_res {
	nfsstat3 status;
	union {
		nfs_fh3 fh;
	} RPC_UNION_NAME(sfsctl_getfh_res);
} sfsctl_getfh_res;
RPC_EXTERN bool_t xdr_sfsctl_getfh_res(XDR *, sfsctl_getfh_res *);
RPC_CONSTRUCT (Sfsctl_getfh_res, sfsctl_getfh_res)

typedef struct sfsctl_getidnames_arg {
	filename3 filesys;
	sfs_idnums nums;
} sfsctl_getidnames_arg;
RPC_EXTERN bool_t xdr_sfsctl_getidnames_arg(XDR *, sfsctl_getidnames_arg *);
RPC_CONSTRUCT (Sfsctl_getidnames_arg, sfsctl_getidnames_arg)

typedef struct sfsctl_getidnames_res {
	nfsstat3 status;
	union {
		sfs_idnames names;
	} RPC_UNION_NAME(sfsctl_getidnames_res);
} sfsctl_getidnames_res;
RPC_EXTERN bool_t xdr_sfsctl_getidnames_res(XDR *, sfsctl_getidnames_res *);
RPC_CONSTRUCT (Sfsctl_getidnames_res, sfsctl_getidnames_res)

typedef struct sfsctl_getidnums_arg {
	filename3 filesys;
	sfs_idnames names;
} sfsctl_getidnums_arg;
RPC_EXTERN bool_t xdr_sfsctl_getidnums_arg(XDR *, sfsctl_getidnums_arg *);
RPC_CONSTRUCT (Sfsctl_getidnums_arg, sfsctl_getidnums_arg)

typedef struct sfsctl_getidnums_res {
	nfsstat3 status;
	union {
		sfs_idnums nums;
	} RPC_UNION_NAME(sfsctl_getidnums_res);
} sfsctl_getidnums_res;
RPC_EXTERN bool_t xdr_sfsctl_getidnums_res(XDR *, sfsctl_getidnums_res *);
RPC_CONSTRUCT (Sfsctl_getidnums_res, sfsctl_getidnums_res)

typedef struct sfsctl_getcred_res {
	nfsstat3 status;
	union {
		sfsauth_cred cred;
	} RPC_UNION_NAME(sfsctl_getcred_res);
} sfsctl_getcred_res;
RPC_EXTERN bool_t xdr_sfsctl_getcred_res(XDR *, sfsctl_getcred_res *);
RPC_CONSTRUCT (Sfsctl_getcred_res, sfsctl_getcred_res)

typedef struct sfsctl_lookup_arg {
	filename3 filesys;
	diropargs3 arg;
} sfsctl_lookup_arg;
RPC_EXTERN bool_t xdr_sfsctl_lookup_arg(XDR *, sfsctl_lookup_arg *);
RPC_CONSTRUCT (Sfsctl_lookup_arg, sfsctl_lookup_arg)

typedef struct sfsctl_getacl_arg {
	filename3 filesys;
	diropargs3 arg;
} sfsctl_getacl_arg;
RPC_EXTERN bool_t xdr_sfsctl_getacl_arg(XDR *, sfsctl_getacl_arg *);
RPC_CONSTRUCT (Sfsctl_getacl_arg, sfsctl_getacl_arg)

typedef struct sfsctl_setacl_arg {
	filename3 filesys;
	setaclargs arg;
} sfsctl_setacl_arg;
RPC_EXTERN bool_t xdr_sfsctl_setacl_arg(XDR *, sfsctl_setacl_arg *);
RPC_CONSTRUCT (Sfsctl_setacl_arg, sfsctl_setacl_arg)

#define AGENTCTL_PROG ((u_long)344428)
RPC_EXTERN const struct rpcgen_table agentctl_prog_1_table[];
RPC_EXTERN const int agentctl_prog_1_nproc;
RPC_EXTERN const struct rpc_program  agentctl_prog_1;
#define AGENTCTL_VERS ((u_long)1)
#define AGENTCTL_NULL ((u_long)0)
#define AGENTCTL_ADDKEY ((u_long)1)
#define AGENTCTL_REMAUTH ((u_long)2)
#define AGENTCTL_REMALLKEYS ((u_long)3)
#define AGENTCTL_DUMPKEYS ((u_long)4)
#define AGENTCTL_CLRCERTPROGS ((u_long)5)
#define AGENTCTL_ADDCERTPROG ((u_long)6)
#define AGENTCTL_DUMPCERTPROGS ((u_long)7)
#define AGENTCTL_CLRREVOKEPROGS ((u_long)8)
#define AGENTCTL_ADDREVOKEPROG ((u_long)9)
#define AGENTCTL_DUMPREVOKEPROGS ((u_long)10)
#define AGENTCTL_SETNOREVOKE ((u_long)11)
#define AGENTCTL_GETNOREVOKE ((u_long)12)
#define AGENTCTL_SYMLINK ((u_long)13)
#define AGENTCTL_RESET ((u_long)14)
#define AGENTCTL_FORWARD ((u_long)15)
#define AGENTCTL_RNDSEED ((u_long)16)
#define AGENTCTL_REX ((u_long)17)
#define AGENTCTL_LISTSESS ((u_long)18)
#define AGENTCTL_KILLSESS ((u_long)19)
#define AGENTCTL_CLRCERTPROG_BYREALM ((u_long)20)
#define AGENTCTL_ADDEXTAUTH ((u_long)21)
#define AGENTCTL_CLRSRPNAMES ((u_long)22)
#define AGENTCTL_ADDSRPNAME ((u_long)23)
#define AGENTCTL_DUMPSRPNAMES ((u_long)24)
#define AGENTCTL_LOOKUPSRPNAME ((u_long)25)

#define SFSEXTAUTH_PROG ((u_long)344429)
RPC_EXTERN const struct rpcgen_table sfsextauth_prog_1_table[];
RPC_EXTERN const int sfsextauth_prog_1_nproc;
RPC_EXTERN const struct rpc_program  sfsextauth_prog_1;
#define SFSEXTAUTH_VERS ((u_long)1)
#define SFSEXTAUTH_NULL ((u_long)0)
#define SFSEXTAUTH_AUTHINIT ((u_long)1)
#define SFSEXTAUTH_AUTHMORE ((u_long)2)

#define SETUID_PROG ((u_long)344430)
RPC_EXTERN const struct rpcgen_table setuid_prog_1_table[];
RPC_EXTERN const int setuid_prog_1_nproc;
RPC_EXTERN const struct rpc_program  setuid_prog_1;
#define SETUID_VERS ((u_long)1)
#define SETUIDPROC_SETUID ((u_long)0)

#define AGENT_PROG ((u_long)344432)
RPC_EXTERN const struct rpcgen_table agent_prog_1_table[];
RPC_EXTERN const int agent_prog_1_nproc;
RPC_EXTERN const struct rpc_program  agent_prog_1;
#define AGENT_VERS ((u_long)1)
#define AGENT_NULL ((u_long)0)
#define AGENT_START ((u_long)1)
#define AGENT_KILL ((u_long)2)
#define AGENT_KILLSTART ((u_long)3)
#define AGENT_SYMLINK ((u_long)4)
#define AGENT_FLUSHNAME ((u_long)5)
#define AGENT_FLUSHNEG ((u_long)6)
#define AGENT_REVOKE ((u_long)7)
#define AGENT_RNDSEED ((u_long)8)
#define AGENT_AIDALLOC ((u_long)9)
#define AGENT_GETAGENT ((u_long)10)

#define AGENTCB_PROG ((u_long)344433)
RPC_EXTERN const struct rpcgen_table agentcb_prog_1_table[];
RPC_EXTERN const int agentcb_prog_1_nproc;
RPC_EXTERN const struct rpc_program  agentcb_prog_1;
#define AGENTCB_VERS ((u_long)1)
#define AGENTCB_NULL ((u_long)0)
#define AGENTCB_AUTHINIT ((u_long)1)
#define AGENTCB_AUTHMORE ((u_long)2)
#define AGENTCB_LOOKUP ((u_long)3)
#define AGENTCB_REVOKED ((u_long)4)
#define AGENTCB_CLONE ((u_long)5)

#define SFSCTL_PROG ((u_long)344434)
RPC_EXTERN const struct rpcgen_table sfsctl_prog_1_table[];
RPC_EXTERN const int sfsctl_prog_1_nproc;
RPC_EXTERN const struct rpc_program  sfsctl_prog_1;
#define SFSCTL_VERS ((u_long)1)
#define SFSCTL_NULL ((u_long)0)
#define SFSCTL_SETPID ((u_long)1)
#define SFSCTL_GETFH ((u_long)2)
#define SFSCTL_GETIDNAMES ((u_long)3)
#define SFSCTL_GETIDNUMS ((u_long)4)
#define SFSCTL_GETCRED ((u_long)5)
#define SFSCTL_LOOKUP ((u_long)6)
#define SFSCTL_GETACL ((u_long)7)
#define SFSCTL_SETACL ((u_long)8)


#endif /* !_SFSAGENT_H_RPCGEN */
