// -*-c++-*-
/* This file was automatically generated by rpcc. */

#include "sfs_prot.h"

#ifdef MAINTAINER

const strbuf &
rpc_print (const strbuf &sb, const sfsstat &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case SFS_OK:
    p = "SFS_OK";
    break;
  case SFS_BADLOGIN:
    p = "SFS_BADLOGIN";
    break;
  case SFS_NOSUCHHOST:
    p = "SFS_NOSUCHHOST";
    break;
  case SFS_NOTSUPP:
    p = "SFS_NOTSUPP";
    break;
  case SFS_TEMPERR:
    p = "SFS_TEMPERR";
    break;
  case SFS_REDIRECT:
    p = "SFS_REDIRECT";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsstat " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_sfsstat (const void *_objp, const strbuf *_sbp, int _recdepth,
               const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsstat *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsstat (const sfsstat *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_msgtype &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case SFS_NULL:
    p = "SFS_NULL";
    break;
  case SFS_HOSTINFO:
    p = "SFS_HOSTINFO";
    break;
  case SFS_KSC:
    p = "SFS_KSC";
    break;
  case SFS_KCS:
    p = "SFS_KCS";
    break;
  case SFS_SESSINFO:
    p = "SFS_SESSINFO";
    break;
  case SFS_AUTHINFO:
    p = "SFS_AUTHINFO";
    break;
  case SFS_SIGNED_AUTHREQ:
    p = "SFS_SIGNED_AUTHREQ";
    break;
  case SFS_AUTHREGISTER:
    p = "SFS_AUTHREGISTER";
    break;
  case SFS_AUTHUPDATE:
    p = "SFS_AUTHUPDATE";
    break;
  case SFS_PATHREVOKE:
    p = "SFS_PATHREVOKE";
    break;
  case SFS_KEYCERT:
    p = "SFS_KEYCERT";
    break;
  case SFS_ROFSINFO:
    p = "SFS_ROFSINFO";
    break;
  case SFS_UPDATEREQ:
    p = "SFS_UPDATEREQ";
    break;
  case SFS_PUBKEY2_HASH:
    p = "SFS_PUBKEY2_HASH";
    break;
  case SFS_SIGNED_AUTHREQ_NOCRED:
    p = "SFS_SIGNED_AUTHREQ_NOCRED";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_msgtype " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_sfs_msgtype (const void *_objp, const strbuf *_sbp, int _recdepth,
                   const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_msgtype *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_msgtype (const sfs_msgtype *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_service &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case SFS_SFS:
    p = "SFS_SFS";
    break;
  case SFS_AUTHSERV:
    p = "SFS_AUTHSERV";
    break;
  case SFS_REX:
    p = "SFS_REX";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_service " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_sfs_service (const void *_objp, const strbuf *_sbp, int _recdepth,
                   const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_service *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_service (const sfs_service *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_extension (const void *_objp, const strbuf *_sbp, int _recdepth,
                     const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_extension *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_extension (const sfs_extension *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_hostname (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_hostname *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_hostname (const sfs_hostname *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_idname (const void *_objp, const strbuf *_sbp, int _recdepth,
                  const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_idname *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_idname (const sfs_idname *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_hash (const void *_objp, const strbuf *_sbp, int _recdepth,
                const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_hash *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_hash (const sfs_hash *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_secret (const void *_objp, const strbuf *_sbp, int _recdepth,
                  const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_secret *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_secret (const sfs_secret *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_seqno (const void *_objp, const strbuf *_sbp, int _recdepth,
                 const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_seqno *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_seqno (const sfs_seqno *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_time (const void *_objp, const strbuf *_sbp, int _recdepth,
                const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_time *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_time (const sfs_time *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_pubkey (const void *_objp, const strbuf *_sbp, int _recdepth,
                  const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_pubkey *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_pubkey (const sfs_pubkey *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_ctext (const void *_objp, const strbuf *_sbp, int _recdepth,
                 const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_ctext *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_ctext (const sfs_ctext *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_sig (const void *_objp, const strbuf *_sbp, int _recdepth,
               const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_sig *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_sig (const sfs_sig *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_keytype &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case SFS_NOKEY:
    p = "SFS_NOKEY";
    break;
  case SFS_RABIN:
    p = "SFS_RABIN";
    break;
  case SFS_2SCHNORR:
    p = "SFS_2SCHNORR";
    break;
  case SFS_SCHNORR:
    p = "SFS_SCHNORR";
    break;
  case SFS_1SCHNORR:
    p = "SFS_1SCHNORR";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_keytype " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_sfs_keytype (const void *_objp, const strbuf *_sbp, int _recdepth,
                   const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_keytype *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_keytype (const sfs_keytype *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_1schnorr_priv_xdr &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_1schnorr_priv_xdr " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.p, recdepth, "p", npref);
  sb << sep;
  rpc_print (sb, obj.q, recdepth, "q", npref);
  sb << sep;
  rpc_print (sb, obj.g, recdepth, "g", npref);
  sb << sep;
  rpc_print (sb, obj.y, recdepth, "y", npref);
  sb << sep;
  rpc_print (sb, obj.x, recdepth, "x", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_1schnorr_priv_xdr (const void *_objp, const strbuf *_sbp, int _recdepth,
                             const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_1schnorr_priv_xdr *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_1schnorr_priv_xdr (const sfs_1schnorr_priv_xdr *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_2schnorr_priv_xdr &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_2schnorr_priv_xdr " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.p, recdepth, "p", npref);
  sb << sep;
  rpc_print (sb, obj.q, recdepth, "q", npref);
  sb << sep;
  rpc_print (sb, obj.g, recdepth, "g", npref);
  sb << sep;
  rpc_print (sb, obj.y, recdepth, "y", npref);
  sb << sep;
  rpc_print (sb, obj.x, recdepth, "x", npref);
  sb << sep;
  rpc_print (sb, obj.hostname, recdepth, "hostname", npref);
  sb << sep;
  rpc_print (sb, obj.uname, recdepth, "uname", npref);
  sb << sep;
  rpc_print (sb, obj.audit, recdepth, "audit", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_2schnorr_priv_xdr (const void *_objp, const strbuf *_sbp, int _recdepth,
                             const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_2schnorr_priv_xdr *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_2schnorr_priv_xdr (const sfs_2schnorr_priv_xdr *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_2schnorr_priv_export &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_2schnorr_priv_export " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.kt, recdepth, "kt", npref);
  sb << sep;
  rpc_print (sb, obj.cksum, recdepth, "cksum", npref);
  sb << sep;
  rpc_print (sb, obj.privkeys, recdepth, "privkeys", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_2schnorr_priv_export (const void *_objp, const strbuf *_sbp, int _recdepth,
                                const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_2schnorr_priv_export *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_2schnorr_priv_export (const sfs_2schnorr_priv_export *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_1schnorr_priv_export &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_1schnorr_priv_export " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.kt, recdepth, "kt", npref);
  sb << sep;
  rpc_print (sb, obj.cksum, recdepth, "cksum", npref);
  sb << sep;
  rpc_print (sb, obj.privkey, recdepth, "privkey", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_1schnorr_priv_export (const void *_objp, const strbuf *_sbp, int _recdepth,
                                const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_1schnorr_priv_export *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_1schnorr_priv_export (const sfs_1schnorr_priv_export *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_schnorr_pub_xdr &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_schnorr_pub_xdr " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.p, recdepth, "p", npref);
  sb << sep;
  rpc_print (sb, obj.q, recdepth, "q", npref);
  sb << sep;
  rpc_print (sb, obj.g, recdepth, "g", npref);
  sb << sep;
  rpc_print (sb, obj.y, recdepth, "y", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_schnorr_pub_xdr (const void *_objp, const strbuf *_sbp, int _recdepth,
                           const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_schnorr_pub_xdr *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_schnorr_pub_xdr (const sfs_schnorr_pub_xdr *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_schnorr_sig &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_schnorr_sig " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.r, recdepth, "r", npref);
  sb << sep;
  rpc_print (sb, obj.s, recdepth, "s", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_schnorr_sig (const void *_objp, const strbuf *_sbp, int _recdepth,
                       const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_schnorr_sig *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_schnorr_sig (const sfs_schnorr_sig *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_2schnorr_presig &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_2schnorr_presig " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.r, recdepth, "r", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_2schnorr_presig (const void *_objp, const strbuf *_sbp, int _recdepth,
                           const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_2schnorr_presig *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_2schnorr_presig (const sfs_2schnorr_presig *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_rabin_priv_export &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_rabin_priv_export " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.p, recdepth, "p", npref);
  sb << sep;
  rpc_print (sb, obj.q, recdepth, "q", npref);
  sb << sep;
  rpc_print (sb, obj.cksum, recdepth, "cksum", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_rabin_priv_export (const void *_objp, const strbuf *_sbp, int _recdepth,
                             const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_rabin_priv_export *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_rabin_priv_export (const sfs_rabin_priv_export *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_rabin_priv_xdr &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_rabin_priv_xdr " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.p, recdepth, "p", npref);
  sb << sep;
  rpc_print (sb, obj.q, recdepth, "q", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_rabin_priv_xdr (const void *_objp, const strbuf *_sbp, int _recdepth,
                          const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_rabin_priv_xdr *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_rabin_priv_xdr (const sfs_rabin_priv_xdr *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_privkey2 (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_privkey2 *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_privkey2 (const sfs_privkey2 *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_pubkey2 &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_pubkey2 " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  switch (obj.type) {
  case SFS_RABIN:
    sb << sep;
    rpc_print (sb, *obj.rabin,  recdepth, "rabin", npref);
    break;
  case SFS_SCHNORR:
    sb << sep;
    rpc_print (sb, *obj.schnorr,  recdepth, "schnorr", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_pubkey2 (const void *_objp, const strbuf *_sbp, int _recdepth,
                   const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_pubkey2 *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_pubkey2 (const sfs_pubkey2 *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_ctext2 &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_ctext2 " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  switch (obj.type) {
  case SFS_RABIN:
    sb << sep;
    rpc_print (sb, *obj.rabin,  recdepth, "rabin", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_ctext2 (const void *_objp, const strbuf *_sbp, int _recdepth,
                  const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_ctext2 *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_ctext2 (const sfs_ctext2 *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_sig2 &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_sig2 " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  switch (obj.type) {
  case SFS_RABIN:
    sb << sep;
    rpc_print (sb, *obj.rabin,  recdepth, "rabin", npref);
    break;
  case SFS_SCHNORR:
    sb << sep;
    rpc_print (sb, *obj.schnorr,  recdepth, "schnorr", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_sig2 (const void *_objp, const strbuf *_sbp, int _recdepth,
                const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_sig2 *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_sig2 (const sfs_sig2 *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_hashcharge &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_hashcharge " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.bitcost, recdepth, "bitcost", npref);
  sb << sep;
  rpc_print (sb, obj.target, recdepth, "target", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_hashcharge (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_hashcharge *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_hashcharge (const sfs_hashcharge *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_hashpay (const void *_objp, const strbuf *_sbp, int _recdepth,
                   const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_hashpay *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_hashpay (const sfs_hashpay *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_hostinfo &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_hostinfo " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  sb << sep;
  rpc_print (sb, obj.hostname, recdepth, "hostname", npref);
  sb << sep;
  rpc_print (sb, obj.pubkey, recdepth, "pubkey", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_hostinfo (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_hostinfo *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_hostinfo (const sfs_hostinfo *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_pubkey2_hash &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_pubkey2_hash " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  sb << sep;
  rpc_print (sb, obj.pubkey, recdepth, "pubkey", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_pubkey2_hash (const void *_objp, const strbuf *_sbp, int _recdepth,
                        const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_pubkey2_hash *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_pubkey2_hash (const sfs_pubkey2_hash *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_hostinfo2 &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_hostinfo2 " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  sb << sep;
  rpc_print (sb, obj.hostname, recdepth, "hostname", npref);
  sb << sep;
  rpc_print (sb, obj.port, recdepth, "port", npref);
  sb << sep;
  rpc_print (sb, obj.pubkey, recdepth, "pubkey", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_hostinfo2 (const void *_objp, const strbuf *_sbp, int _recdepth,
                     const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_hostinfo2 *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_hostinfo2 (const sfs_hostinfo2 *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_connectinfo_4 &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_connectinfo_4 " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.service, recdepth, "service", npref);
  sb << sep;
  rpc_print (sb, obj.name, recdepth, "name", npref);
  sb << sep;
  rpc_print (sb, obj.hostid, recdepth, "hostid", npref);
  sb << sep;
  rpc_print (sb, obj.extensions, recdepth, "extensions", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_connectinfo_4 (const void *_objp, const strbuf *_sbp, int _recdepth,
                         const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_connectinfo_4 *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_connectinfo_4 (const sfs_connectinfo_4 *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_connectinfo_5 &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_connectinfo_5 " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.release, recdepth, "release", npref);
  sb << sep;
  rpc_print (sb, obj.service, recdepth, "service", npref);
  sb << sep;
  rpc_print (sb, obj.sname, recdepth, "sname", npref);
  sb << sep;
  rpc_print (sb, obj.extensions, recdepth, "extensions", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_connectinfo_5 (const void *_objp, const strbuf *_sbp, int _recdepth,
                         const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_connectinfo_5 *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_connectinfo_5 (const sfs_connectinfo_5 *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_connectinfo &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_connectinfo " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.civers, recdepth, "civers", npref);
  switch (obj.civers) {
  case 4:
    sb << sep;
    rpc_print (sb, *obj.ci4,  recdepth, "ci4", npref);
    break;
  case 5:
    sb << sep;
    rpc_print (sb, *obj.ci5,  recdepth, "ci5", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_connectinfo (const void *_objp, const strbuf *_sbp, int _recdepth,
                       const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_connectinfo *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_connectinfo (const sfs_connectinfo *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_servinfo_5 &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_servinfo_5 " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.host, recdepth, "host", npref);
  sb << sep;
  rpc_print (sb, obj.prog, recdepth, "prog", npref);
  sb << sep;
  rpc_print (sb, obj.vers, recdepth, "vers", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_servinfo_5 (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_servinfo_5 *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_servinfo_5 (const sfs_servinfo_5 *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_servinfo_7 &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_servinfo_7 " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.release, recdepth, "release", npref);
  sb << sep;
  rpc_print (sb, obj.host, recdepth, "host", npref);
  sb << sep;
  rpc_print (sb, obj.prog, recdepth, "prog", npref);
  sb << sep;
  rpc_print (sb, obj.vers, recdepth, "vers", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_servinfo_7 (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_servinfo_7 *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_servinfo_7 (const sfs_servinfo_7 *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_servinfo &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_servinfo " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.sivers, recdepth, "sivers", npref);
  switch (obj.sivers) {
  case 5:
  case 6:
    sb << sep;
    rpc_print (sb, *obj.cr5,  recdepth, "cr5", npref);
    break;
  case 7:
    sb << sep;
    rpc_print (sb, *obj.cr7,  recdepth, "cr7", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_servinfo (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_servinfo *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_servinfo (const sfs_servinfo *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_sesskeydat &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_sesskeydat " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  sb << sep;
  rpc_print (sb, obj.si, recdepth, "si", npref);
  sb << sep;
  rpc_print (sb, obj.sshare, recdepth, "sshare", npref);
  sb << sep;
  rpc_print (sb, obj.ci, recdepth, "ci", npref);
  sb << sep;
  rpc_print (sb, obj.kc, recdepth, "kc", npref);
  sb << sep;
  rpc_print (sb, obj.cshare, recdepth, "cshare", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_sesskeydat (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_sesskeydat *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_sesskeydat (const sfs_sesskeydat *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_sessinfo &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_sessinfo " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  sb << sep;
  rpc_print (sb, obj.ksc, recdepth, "ksc", npref);
  sb << sep;
  rpc_print (sb, obj.kcs, recdepth, "kcs", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_sessinfo (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_sessinfo *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_sessinfo (const sfs_sessinfo *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_authinfo &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_authinfo " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  sb << sep;
  rpc_print (sb, obj.service, recdepth, "service", npref);
  sb << sep;
  rpc_print (sb, obj.name, recdepth, "name", npref);
  sb << sep;
  rpc_print (sb, obj.hostid, recdepth, "hostid", npref);
  sb << sep;
  rpc_print (sb, obj.sessid, recdepth, "sessid", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_authinfo (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_authinfo *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_authinfo (const sfs_authinfo *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_kmsg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_kmsg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.kcs_share, recdepth, "kcs_share", npref);
  sb << sep;
  rpc_print (sb, obj.ksc_share, recdepth, "ksc_share", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_kmsg (const void *_objp, const strbuf *_sbp, int _recdepth,
                const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_kmsg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_kmsg (const sfs_kmsg *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_keycert_msg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_keycert_msg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  sb << sep;
  rpc_print (sb, obj.duration, recdepth, "duration", npref);
  sb << sep;
  rpc_print (sb, obj.start, recdepth, "start", npref);
  sb << sep;
  rpc_print (sb, obj.key, recdepth, "key", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_keycert_msg (const void *_objp, const strbuf *_sbp, int _recdepth,
                       const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_keycert_msg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_keycert_msg (const sfs_keycert_msg *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_keycert &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_keycert " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.msg, recdepth, "msg", npref);
  sb << sep;
  rpc_print (sb, obj.sig, recdepth, "sig", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_keycert (const void *_objp, const strbuf *_sbp, int _recdepth,
                   const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_keycert *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_keycert (const sfs_keycert *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_signed_authreq &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_signed_authreq " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  sb << sep;
  rpc_print (sb, obj.authid, recdepth, "authid", npref);
  sb << sep;
  rpc_print (sb, obj.seqno, recdepth, "seqno", npref);
  sb << sep;
  rpc_print (sb, obj.usrinfo, recdepth, "usrinfo", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_signed_authreq (const void *_objp, const strbuf *_sbp, int _recdepth,
                          const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_signed_authreq *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_signed_authreq (const sfs_signed_authreq *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_redirect &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_redirect " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.serial, recdepth, "serial", npref);
  sb << sep;
  rpc_print (sb, obj.expire, recdepth, "expire", npref);
  sb << sep;
  rpc_print (sb, obj.hostinfo, recdepth, "hostinfo", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_redirect (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_redirect *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_redirect (const sfs_redirect *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_pathrevoke_msg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_pathrevoke_msg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  sb << sep;
  rpc_print (sb, obj.path, recdepth, "path", npref);
  sb << sep;
  rpc_print (sb, obj.redirect, recdepth, "redirect", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_pathrevoke_msg (const void *_objp, const strbuf *_sbp, int _recdepth,
                          const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_pathrevoke_msg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_pathrevoke_msg (const sfs_pathrevoke_msg *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_pathrevoke &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_pathrevoke " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.msg, recdepth, "msg", npref);
  sb << sep;
  rpc_print (sb, obj.sig, recdepth, "sig", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_pathrevoke (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_pathrevoke *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_pathrevoke (const sfs_pathrevoke *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_connectarg (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_connectarg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_connectarg (const sfs_connectarg *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_connectok &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_connectok " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.servinfo, recdepth, "servinfo", npref);
  sb << sep;
  rpc_print (sb, obj.charge, recdepth, "charge", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_connectok (const void *_objp, const strbuf *_sbp, int _recdepth,
                     const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_connectok *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_connectok (const sfs_connectok *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_connectres &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_connectres " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.status, recdepth, "status", npref);
  switch (obj.status) {
  case SFS_OK:
    sb << sep;
    rpc_print (sb, *obj.reply,  recdepth, "reply", npref);
    break;
  case SFS_REDIRECT:
    sb << sep;
    rpc_print (sb, *obj.revoke,  recdepth, "revoke", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_connectres (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_connectres *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_connectres (const sfs_connectres *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_encryptarg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_encryptarg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.payment, recdepth, "payment", npref);
  sb << sep;
  rpc_print (sb, obj.kmsg, recdepth, "kmsg", npref);
  sb << sep;
  rpc_print (sb, obj.pubkey, recdepth, "pubkey", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_encryptarg (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_encryptarg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_encryptarg (const sfs_encryptarg *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_encryptarg2 &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_encryptarg2 " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.payment, recdepth, "payment", npref);
  sb << sep;
  rpc_print (sb, obj.kmsg, recdepth, "kmsg", npref);
  sb << sep;
  rpc_print (sb, obj.pubkey, recdepth, "pubkey", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_encryptarg2 (const void *_objp, const strbuf *_sbp, int _recdepth,
                       const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_encryptarg2 *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_encryptarg2 (const sfs_encryptarg2 *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_encryptres (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_encryptres *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_encryptres (const sfs_encryptres *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfs_encryptres2 (const void *_objp, const strbuf *_sbp, int _recdepth,
                       const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_encryptres2 *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_encryptres2 (const sfs_encryptres2 *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_nfs3_subfs &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_nfs3_subfs " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.path, recdepth, "path", npref);
  sb << sep;
  rpc_print (sb, obj.fh, recdepth, "fh", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_nfs3_subfs (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_nfs3_subfs *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_nfs3_subfs (const sfs_nfs3_subfs *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_nfs3_fsinfo &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_nfs3_fsinfo " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.root, recdepth, "root", npref);
  sb << sep;
  rpc_print (sb, obj.subfs, recdepth, "subfs", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_nfs3_fsinfo (const void *_objp, const strbuf *_sbp, int _recdepth,
                       const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_nfs3_fsinfo *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_nfs3_fsinfo (const sfs_nfs3_fsinfo *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_nfs_fsinfo &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_nfs_fsinfo " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.vers, recdepth, "vers", npref);
  switch (obj.vers) {
  case ex_NFS_V3:
    sb << sep;
    rpc_print (sb, *obj.v3,  recdepth, "v3", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_nfs_fsinfo (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_nfs_fsinfo *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_nfs_fsinfo (const sfs_nfs_fsinfo *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_fsinfo &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_fsinfo " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.prog, recdepth, "prog", npref);
  switch (obj.prog) {
  case ex_NFS_PROGRAM:
    sb << sep;
    rpc_print (sb, *obj.nfs,  recdepth, "nfs", npref);
    break;
  case 344446:
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_fsinfo (const void *_objp, const strbuf *_sbp, int _recdepth,
                  const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_fsinfo *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_fsinfo (const sfs_fsinfo *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_opt_idname &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_opt_idname " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.present, recdepth, "present", npref);
  switch (obj.present) {
  case true:
    sb << sep;
    rpc_print (sb, *obj.name,  recdepth, "name", npref);
    break;
  case false:
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_opt_idname (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_opt_idname *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_opt_idname (const sfs_opt_idname *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_idnums &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_idnums " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.uid, recdepth, "uid", npref);
  sb << sep;
  rpc_print (sb, obj.gid, recdepth, "gid", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_idnums (const void *_objp, const strbuf *_sbp, int _recdepth,
                  const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_idnums *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_idnums (const sfs_idnums *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_idnames &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_idnames " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.uidname, recdepth, "uidname", npref);
  sb << sep;
  rpc_print (sb, obj.gidname, recdepth, "gidname", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_idnames (const void *_objp, const strbuf *_sbp, int _recdepth,
                   const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_idnames *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_idnames (const sfs_idnames *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_loginstat &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case SFSLOGIN_OK:
    p = "SFSLOGIN_OK";
    break;
  case SFSLOGIN_MORE:
    p = "SFSLOGIN_MORE";
    break;
  case SFSLOGIN_BAD:
    p = "SFSLOGIN_BAD";
    break;
  case SFSLOGIN_ALLBAD:
    p = "SFSLOGIN_ALLBAD";
    break;
  case SFSLOGIN_AGAIN:
    p = "SFSLOGIN_AGAIN";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_loginstat " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_sfs_loginstat (const void *_objp, const strbuf *_sbp, int _recdepth,
                     const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_loginstat *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_loginstat (const sfs_loginstat *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_loginres &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_loginres " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.status, recdepth, "status", npref);
  switch (obj.status) {
  case SFSLOGIN_OK:
    sb << sep;
    rpc_print (sb, *obj.authno,  recdepth, "authno", npref);
    break;
  case SFSLOGIN_MORE:
    sb << sep;
    rpc_print (sb, *obj.resmore,  recdepth, "resmore", npref);
    break;
  case SFSLOGIN_BAD:
  case SFSLOGIN_ALLBAD:
  case SFSLOGIN_AGAIN:
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_loginres (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_loginres *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_loginres (const sfs_loginres *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_loginarg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_loginarg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.seqno, recdepth, "seqno", npref);
  sb << sep;
  rpc_print (sb, obj.certificate, recdepth, "certificate", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_loginarg (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_loginarg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_loginarg (const sfs_loginarg *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_stat &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case SFSAUTH_OK:
    p = "SFSAUTH_OK";
    break;
  case SFSAUTH_LOGINMORE:
    p = "SFSAUTH_LOGINMORE";
    break;
  case SFSAUTH_FAILED:
    p = "SFSAUTH_FAILED";
    break;
  case SFSAUTH_LOGINALLBAD:
    p = "SFSAUTH_LOGINALLBAD";
    break;
  case SFSAUTH_NOTSOCK:
    p = "SFSAUTH_NOTSOCK";
    break;
  case SFSAUTH_BADUSERNAME:
    p = "SFSAUTH_BADUSERNAME";
    break;
  case SFSAUTH_WRONGUID:
    p = "SFSAUTH_WRONGUID";
    break;
  case SFSAUTH_DENYROOT:
    p = "SFSAUTH_DENYROOT";
    break;
  case SFSAUTH_BADSHELL:
    p = "SFSAUTH_BADSHELL";
    break;
  case SFSAUTH_DENYFILE:
    p = "SFSAUTH_DENYFILE";
    break;
  case SFSAUTH_BADPASSWORD:
    p = "SFSAUTH_BADPASSWORD";
    break;
  case SFSAUTH_USEREXISTS:
    p = "SFSAUTH_USEREXISTS";
    break;
  case SFSAUTH_NOCHANGES:
    p = "SFSAUTH_NOCHANGES";
    break;
  case SFSAUTH_NOSRP:
    p = "SFSAUTH_NOSRP";
    break;
  case SFSAUTH_BADSIGNATURE:
    p = "SFSAUTH_BADSIGNATURE";
    break;
  case SFSAUTH_PROTOERR:
    p = "SFSAUTH_PROTOERR";
    break;
  case SFSAUTH_NOTTHERE:
    p = "SFSAUTH_NOTTHERE";
    break;
  case SFSAUTH_BADAUTHID:
    p = "SFSAUTH_BADAUTHID";
    break;
  case SFSAUTH_KEYEXISTS:
    p = "SFSAUTH_KEYEXISTS";
    break;
  case SFSAUTH_BADKEYNAME:
    p = "SFSAUTH_BADKEYNAME";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_stat " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_sfsauth_stat (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_stat *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_stat (const sfsauth_stat *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_authtype &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case SFS_NOAUTH:
    p = "SFS_NOAUTH";
    break;
  case SFS_AUTHREQ:
    p = "SFS_AUTHREQ";
    break;
  case SFS_AUTHREQ2:
    p = "SFS_AUTHREQ2";
    break;
  case SFS_SRPAUTH:
    p = "SFS_SRPAUTH";
    break;
  case SFS_UNIXPWAUTH:
    p = "SFS_UNIXPWAUTH";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_authtype " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_sfs_authtype (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_authtype *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_authtype (const sfs_authtype *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_authreq &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_authreq " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.usrkey, recdepth, "usrkey", npref);
  sb << sep;
  rpc_print (sb, obj.signed_req, recdepth, "signed_req", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_authreq (const void *_objp, const strbuf *_sbp, int _recdepth,
                   const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_authreq *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_authreq (const sfs_authreq *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_autharg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_autharg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  switch (obj.type) {
  case SFS_NOAUTH:
    break;
  case SFS_AUTHREQ:
    sb << sep;
    rpc_print (sb, *obj.req,  recdepth, "req", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_autharg (const void *_objp, const strbuf *_sbp, int _recdepth,
                   const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_autharg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_autharg (const sfs_autharg *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_credtype &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case SFS_NOCRED:
    p = "SFS_NOCRED";
    break;
  case SFS_UNIXCRED:
    p = "SFS_UNIXCRED";
    break;
  case SFS_PKCRED:
    p = "SFS_PKCRED";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_credtype " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_sfs_credtype (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_credtype *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_credtype (const sfs_credtype *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_unixcred &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_unixcred " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.username, recdepth, "username", npref);
  sb << sep;
  rpc_print (sb, obj.homedir, recdepth, "homedir", npref);
  sb << sep;
  rpc_print (sb, obj.shell, recdepth, "shell", npref);
  sb << sep;
  rpc_print (sb, obj.uid, recdepth, "uid", npref);
  sb << sep;
  rpc_print (sb, obj.gid, recdepth, "gid", npref);
  sb << sep;
  rpc_print (sb, obj.groups, recdepth, "groups", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfs_unixcred (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_unixcred *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_unixcred (const sfs_unixcred *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_cred &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_cred " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  switch (obj.type) {
  case SFS_NOCRED:
    break;
  case SFS_UNIXCRED:
    sb << sep;
    rpc_print (sb, *obj.unixcred,  recdepth, "unixcred", npref);
    break;
  case SFS_PKCRED:
    sb << sep;
    rpc_print (sb, *obj.pkhash,  recdepth, "pkhash", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_cred (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_cred *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_cred (const sfsauth_cred *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_loginokres &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_loginokres " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.cred, recdepth, "cred", npref);
  sb << sep;
  rpc_print (sb, obj.authid, recdepth, "authid", npref);
  sb << sep;
  rpc_print (sb, obj.seqno, recdepth, "seqno", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_loginokres (const void *_objp, const strbuf *_sbp, int _recdepth,
                          const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_loginokres *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_loginokres (const sfsauth_loginokres *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_loginres &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_loginres " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.status, recdepth, "status", npref);
  switch (obj.status) {
  case SFSLOGIN_OK:
    sb << sep;
    rpc_print (sb, *obj.resok,  recdepth, "resok", npref);
    break;
  case SFSLOGIN_MORE:
    sb << sep;
    rpc_print (sb, *obj.resmore,  recdepth, "resmore", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_loginres (const void *_objp, const strbuf *_sbp, int _recdepth,
                        const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_loginres *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_loginres (const sfsauth_loginres *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfssrp_parms &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfssrp_parms " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.N, recdepth, "N", npref);
  sb << sep;
  rpc_print (sb, obj.g, recdepth, "g", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfssrp_parms (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfssrp_parms *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfssrp_parms (const sfssrp_parms *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_srpparmsres &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_srpparmsres " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.status, recdepth, "status", npref);
  switch (obj.status) {
  case SFSAUTH_OK:
    sb << sep;
    rpc_print (sb, *obj.parms,  recdepth, "parms", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_srpparmsres (const void *_objp, const strbuf *_sbp, int _recdepth,
                           const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_srpparmsres *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_srpparmsres (const sfsauth_srpparmsres *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfssrp_bytes (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfssrp_bytes *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfssrp_bytes (const sfssrp_bytes *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfssrp_init_arg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfssrp_init_arg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.username, recdepth, "username", npref);
  sb << sep;
  rpc_print (sb, obj.msg, recdepth, "msg", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfssrp_init_arg (const void *_objp, const strbuf *_sbp, int _recdepth,
                       const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfssrp_init_arg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfssrp_init_arg (const sfssrp_init_arg *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_srpres &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_srpres " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.status, recdepth, "status", npref);
  switch (obj.status) {
  case SFSAUTH_OK:
    sb << sep;
    rpc_print (sb, *obj.msg,  recdepth, "msg", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_srpres (const void *_objp, const strbuf *_sbp, int _recdepth,
                      const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_srpres *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_srpres (const sfsauth_srpres *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_fetchresok &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_fetchresok " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.privkey, recdepth, "privkey", npref);
  sb << sep;
  rpc_print (sb, obj.hostid, recdepth, "hostid", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_fetchresok (const void *_objp, const strbuf *_sbp, int _recdepth,
                          const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_fetchresok *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_fetchresok (const sfsauth_fetchresok *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_fetchres &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_fetchres " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.status, recdepth, "status", npref);
  switch (obj.status) {
  case SFSAUTH_OK:
    sb << sep;
    rpc_print (sb, *obj.resok,  recdepth, "resok", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_fetchres (const void *_objp, const strbuf *_sbp, int _recdepth,
                        const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_fetchres *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_fetchres (const sfsauth_fetchres *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfsauth_realm (const void *_objp, const strbuf *_sbp, int _recdepth,
                     const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_realm *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_realm (const sfsauth_realm *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfsauth_certpath (const void *_objp, const strbuf *_sbp, int _recdepth,
                        const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_certpath *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_certpath (const sfsauth_certpath *objp)
{
  rpc_print (warnx, *objp);
}

void
print_sfsauth_certpaths (const void *_objp, const strbuf *_sbp, int _recdepth,
                         const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_certpaths *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_certpaths (const sfsauth_certpaths *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfs_certstat &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case SFSAUTH_CERT_SELF:
    p = "SFSAUTH_CERT_SELF";
    break;
  case SFSAUTH_CERT_REALM:
    p = "SFSAUTH_CERT_REALM";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfs_certstat " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_sfs_certstat (const void *_objp, const strbuf *_sbp, int _recdepth,
                    const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfs_certstat *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfs_certstat (const sfs_certstat *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_certinfo_info &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_certinfo_info " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.status, recdepth, "status", npref);
  switch (obj.status) {
  case SFSAUTH_CERT_SELF:
    break;
  case SFSAUTH_CERT_REALM:
    sb << sep;
    rpc_print (sb, *obj.certpaths,  recdepth, "certpaths", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_certinfo_info (const void *_objp, const strbuf *_sbp, int _recdepth,
                             const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_certinfo_info *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_certinfo_info (const sfsauth_certinfo_info *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_certinfores &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_certinfores " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.name, recdepth, "name", npref);
  sb << sep;
  rpc_print (sb, obj.info, recdepth, "info", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_certinfores (const void *_objp, const strbuf *_sbp, int _recdepth,
                           const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_certinfores *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_certinfores (const sfsauth_certinfores *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_srpinfo &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_srpinfo " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.info, recdepth, "info", npref);
  sb << sep;
  rpc_print (sb, obj.privkey, recdepth, "privkey", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_srpinfo (const void *_objp, const strbuf *_sbp, int _recdepth,
                       const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_srpinfo *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_srpinfo (const sfsauth_srpinfo *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_registermsg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_registermsg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  sb << sep;
  rpc_print (sb, obj.username, recdepth, "username", npref);
  sb << sep;
  rpc_print (sb, obj.password, recdepth, "password", npref);
  sb << sep;
  rpc_print (sb, obj.pubkey, recdepth, "pubkey", npref);
  sb << sep;
  rpc_print (sb, obj.srpinfo, recdepth, "srpinfo", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_registermsg (const void *_objp, const strbuf *_sbp, int _recdepth,
                           const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_registermsg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_registermsg (const sfsauth_registermsg *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_registerarg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_registerarg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.msg, recdepth, "msg", npref);
  sb << sep;
  rpc_print (sb, obj.sig, recdepth, "sig", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_registerarg (const void *_objp, const strbuf *_sbp, int _recdepth,
                           const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_registerarg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_registerarg (const sfsauth_registerarg *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_registerres &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case SFSAUTH_REGISTER_OK:
    p = "SFSAUTH_REGISTER_OK";
    break;
  case SFSAUTH_REGISTER_NOTSOCK:
    p = "SFSAUTH_REGISTER_NOTSOCK";
    break;
  case SFSAUTH_REGISTER_BADUSERNAME:
    p = "SFSAUTH_REGISTER_BADUSERNAME";
    break;
  case SFSAUTH_REGISTER_WRONGUID:
    p = "SFSAUTH_REGISTER_WRONGUID";
    break;
  case SFSAUTH_REGISTER_DENYROOT:
    p = "SFSAUTH_REGISTER_DENYROOT";
    break;
  case SFSAUTH_REGISTER_BADSHELL:
    p = "SFSAUTH_REGISTER_BADSHELL";
    break;
  case SFSAUTH_REGISTER_DENYFILE:
    p = "SFSAUTH_REGISTER_DENYFILE";
    break;
  case SFSAUTH_REGISTER_BADPASSWORD:
    p = "SFSAUTH_REGISTER_BADPASSWORD";
    break;
  case SFSAUTH_REGISTER_USEREXISTS:
    p = "SFSAUTH_REGISTER_USEREXISTS";
    break;
  case SFSAUTH_REGISTER_FAILED:
    p = "SFSAUTH_REGISTER_FAILED";
    break;
  case SFSAUTH_REGISTER_NOCHANGES:
    p = "SFSAUTH_REGISTER_NOCHANGES";
    break;
  case SFSAUTH_REGISTER_NOSRP:
    p = "SFSAUTH_REGISTER_NOSRP";
    break;
  case SFSAUTH_REGISTER_BADSIG:
    p = "SFSAUTH_REGISTER_BADSIG";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_registerres " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_sfsauth_registerres (const void *_objp, const strbuf *_sbp, int _recdepth,
                           const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_registerres *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_registerres (const sfsauth_registerres *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_updatemsg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_updatemsg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  sb << sep;
  rpc_print (sb, obj.authid, recdepth, "authid", npref);
  sb << sep;
  rpc_print (sb, obj.oldkey, recdepth, "oldkey", npref);
  sb << sep;
  rpc_print (sb, obj.newkey, recdepth, "newkey", npref);
  sb << sep;
  rpc_print (sb, obj.srpinfo, recdepth, "srpinfo", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_updatemsg (const void *_objp, const strbuf *_sbp, int _recdepth,
                         const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_updatemsg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_updatemsg (const sfsauth_updatemsg *objp)
{
  rpc_print (warnx, *objp);
}

const strbuf &
rpc_print (const strbuf &sb, const sfsauth_updatearg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sfsauth_updatearg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.msg, recdepth, "msg", npref);
  sb << sep;
  rpc_print (sb, obj.osig, recdepth, "osig", npref);
  sb << sep;
  rpc_print (sb, obj.nsig, recdepth, "nsig", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sfsauth_updatearg (const void *_objp, const strbuf *_sbp, int _recdepth,
                         const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<const sfsauth_updatearg *> (_objp),
             _recdepth, _name, _prefix);
}
void
dump_sfsauth_updatearg (const sfsauth_updatearg *objp)
{
  rpc_print (warnx, *objp);
}

#endif /* MAINTAINER*/
void *
sfsstat_alloc ()
{
  return New sfsstat;
}
bool_t
xdr_sfsstat (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsstat *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsstat *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_msgtype_alloc ()
{
  return New sfs_msgtype;
}
bool_t
xdr_sfs_msgtype (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_msgtype *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_msgtype *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_service_alloc ()
{
  return New sfs_service;
}
bool_t
xdr_sfs_service (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_service *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_service *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_extension_alloc ()
{
  return New sfs_extension;
}
bool_t
xdr_sfs_extension (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_extension *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_extension *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_hostname_alloc ()
{
  return New sfs_hostname;
}
bool_t
xdr_sfs_hostname (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_hostname *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_hostname *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_idname_alloc ()
{
  return New sfs_idname;
}
bool_t
xdr_sfs_idname (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_idname *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_idname *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_hash_alloc ()
{
  return New sfs_hash;
}
bool_t
xdr_sfs_hash (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_hash *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_hash *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_secret_alloc ()
{
  return New sfs_secret;
}
bool_t
xdr_sfs_secret (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_secret *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_secret *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_seqno_alloc ()
{
  return New sfs_seqno;
}
bool_t
xdr_sfs_seqno (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_seqno *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_seqno *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_time_alloc ()
{
  return New sfs_time;
}
bool_t
xdr_sfs_time (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_time *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_time *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_pubkey_alloc ()
{
  return New sfs_pubkey;
}
bool_t
xdr_sfs_pubkey (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_pubkey *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_pubkey *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_ctext_alloc ()
{
  return New sfs_ctext;
}
bool_t
xdr_sfs_ctext (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_ctext *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_ctext *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_sig_alloc ()
{
  return New sfs_sig;
}
bool_t
xdr_sfs_sig (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_sig *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_sig *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_keytype_alloc ()
{
  return New sfs_keytype;
}
bool_t
xdr_sfs_keytype (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_keytype *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_keytype *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_1schnorr_priv_xdr_alloc ()
{
  return New sfs_1schnorr_priv_xdr;
}
bool_t
xdr_sfs_1schnorr_priv_xdr (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_1schnorr_priv_xdr *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_1schnorr_priv_xdr *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_2schnorr_priv_xdr_alloc ()
{
  return New sfs_2schnorr_priv_xdr;
}
bool_t
xdr_sfs_2schnorr_priv_xdr (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_2schnorr_priv_xdr *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_2schnorr_priv_xdr *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_2schnorr_priv_export_alloc ()
{
  return New sfs_2schnorr_priv_export;
}
bool_t
xdr_sfs_2schnorr_priv_export (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_2schnorr_priv_export *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_2schnorr_priv_export *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_1schnorr_priv_export_alloc ()
{
  return New sfs_1schnorr_priv_export;
}
bool_t
xdr_sfs_1schnorr_priv_export (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_1schnorr_priv_export *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_1schnorr_priv_export *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_schnorr_pub_xdr_alloc ()
{
  return New sfs_schnorr_pub_xdr;
}
bool_t
xdr_sfs_schnorr_pub_xdr (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_schnorr_pub_xdr *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_schnorr_pub_xdr *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_schnorr_sig_alloc ()
{
  return New sfs_schnorr_sig;
}
bool_t
xdr_sfs_schnorr_sig (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_schnorr_sig *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_schnorr_sig *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_2schnorr_presig_alloc ()
{
  return New sfs_2schnorr_presig;
}
bool_t
xdr_sfs_2schnorr_presig (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_2schnorr_presig *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_2schnorr_presig *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_rabin_priv_export_alloc ()
{
  return New sfs_rabin_priv_export;
}
bool_t
xdr_sfs_rabin_priv_export (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_rabin_priv_export *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_rabin_priv_export *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_rabin_priv_xdr_alloc ()
{
  return New sfs_rabin_priv_xdr;
}
bool_t
xdr_sfs_rabin_priv_xdr (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_rabin_priv_xdr *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_rabin_priv_xdr *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_privkey2_alloc ()
{
  return New sfs_privkey2;
}
bool_t
xdr_sfs_privkey2 (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_privkey2 *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_privkey2 *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_pubkey2_alloc ()
{
  return New sfs_pubkey2;
}
bool_t
xdr_sfs_pubkey2 (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_pubkey2 *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_pubkey2 *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_ctext2_alloc ()
{
  return New sfs_ctext2;
}
bool_t
xdr_sfs_ctext2 (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_ctext2 *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_ctext2 *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_sig2_alloc ()
{
  return New sfs_sig2;
}
bool_t
xdr_sfs_sig2 (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_sig2 *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_sig2 *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_hashcharge_alloc ()
{
  return New sfs_hashcharge;
}
bool_t
xdr_sfs_hashcharge (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_hashcharge *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_hashcharge *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_hashpay_alloc ()
{
  return New sfs_hashpay;
}
bool_t
xdr_sfs_hashpay (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_hashpay *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_hashpay *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_hostinfo_alloc ()
{
  return New sfs_hostinfo;
}
bool_t
xdr_sfs_hostinfo (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_hostinfo *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_hostinfo *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_pubkey2_hash_alloc ()
{
  return New sfs_pubkey2_hash;
}
bool_t
xdr_sfs_pubkey2_hash (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_pubkey2_hash *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_pubkey2_hash *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_hostinfo2_alloc ()
{
  return New sfs_hostinfo2;
}
bool_t
xdr_sfs_hostinfo2 (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_hostinfo2 *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_hostinfo2 *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_connectinfo_4_alloc ()
{
  return New sfs_connectinfo_4;
}
bool_t
xdr_sfs_connectinfo_4 (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_connectinfo_4 *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_connectinfo_4 *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_connectinfo_5_alloc ()
{
  return New sfs_connectinfo_5;
}
bool_t
xdr_sfs_connectinfo_5 (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_connectinfo_5 *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_connectinfo_5 *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_connectinfo_alloc ()
{
  return New sfs_connectinfo;
}
bool_t
xdr_sfs_connectinfo (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_connectinfo *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_connectinfo *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_servinfo_5_alloc ()
{
  return New sfs_servinfo_5;
}
bool_t
xdr_sfs_servinfo_5 (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_servinfo_5 *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_servinfo_5 *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_servinfo_7_alloc ()
{
  return New sfs_servinfo_7;
}
bool_t
xdr_sfs_servinfo_7 (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_servinfo_7 *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_servinfo_7 *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_servinfo_alloc ()
{
  return New sfs_servinfo;
}
bool_t
xdr_sfs_servinfo (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_servinfo *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_servinfo *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_sesskeydat_alloc ()
{
  return New sfs_sesskeydat;
}
bool_t
xdr_sfs_sesskeydat (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_sesskeydat *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_sesskeydat *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_sessinfo_alloc ()
{
  return New sfs_sessinfo;
}
bool_t
xdr_sfs_sessinfo (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_sessinfo *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_sessinfo *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_authinfo_alloc ()
{
  return New sfs_authinfo;
}
bool_t
xdr_sfs_authinfo (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_authinfo *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_authinfo *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_kmsg_alloc ()
{
  return New sfs_kmsg;
}
bool_t
xdr_sfs_kmsg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_kmsg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_kmsg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_keycert_msg_alloc ()
{
  return New sfs_keycert_msg;
}
bool_t
xdr_sfs_keycert_msg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_keycert_msg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_keycert_msg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_keycert_alloc ()
{
  return New sfs_keycert;
}
bool_t
xdr_sfs_keycert (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_keycert *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_keycert *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_signed_authreq_alloc ()
{
  return New sfs_signed_authreq;
}
bool_t
xdr_sfs_signed_authreq (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_signed_authreq *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_signed_authreq *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_redirect_alloc ()
{
  return New sfs_redirect;
}
bool_t
xdr_sfs_redirect (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_redirect *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_redirect *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_pathrevoke_msg_alloc ()
{
  return New sfs_pathrevoke_msg;
}
bool_t
xdr_sfs_pathrevoke_msg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_pathrevoke_msg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_pathrevoke_msg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_pathrevoke_alloc ()
{
  return New sfs_pathrevoke;
}
bool_t
xdr_sfs_pathrevoke (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_pathrevoke *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_pathrevoke *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_connectarg_alloc ()
{
  return New sfs_connectarg;
}
bool_t
xdr_sfs_connectarg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_connectarg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_connectarg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_connectok_alloc ()
{
  return New sfs_connectok;
}
bool_t
xdr_sfs_connectok (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_connectok *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_connectok *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_connectres_alloc ()
{
  return New sfs_connectres;
}
bool_t
xdr_sfs_connectres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_connectres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_connectres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_encryptarg_alloc ()
{
  return New sfs_encryptarg;
}
bool_t
xdr_sfs_encryptarg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_encryptarg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_encryptarg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_encryptarg2_alloc ()
{
  return New sfs_encryptarg2;
}
bool_t
xdr_sfs_encryptarg2 (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_encryptarg2 *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_encryptarg2 *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_encryptres_alloc ()
{
  return New sfs_encryptres;
}
bool_t
xdr_sfs_encryptres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_encryptres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_encryptres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_encryptres2_alloc ()
{
  return New sfs_encryptres2;
}
bool_t
xdr_sfs_encryptres2 (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_encryptres2 *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_encryptres2 *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_nfs3_subfs_alloc ()
{
  return New sfs_nfs3_subfs;
}
bool_t
xdr_sfs_nfs3_subfs (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_nfs3_subfs *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_nfs3_subfs *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_nfs3_fsinfo_alloc ()
{
  return New sfs_nfs3_fsinfo;
}
bool_t
xdr_sfs_nfs3_fsinfo (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_nfs3_fsinfo *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_nfs3_fsinfo *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_nfs_fsinfo_alloc ()
{
  return New sfs_nfs_fsinfo;
}
bool_t
xdr_sfs_nfs_fsinfo (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_nfs_fsinfo *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_nfs_fsinfo *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_fsinfo_alloc ()
{
  return New sfs_fsinfo;
}
bool_t
xdr_sfs_fsinfo (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_fsinfo *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_fsinfo *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_opt_idname_alloc ()
{
  return New sfs_opt_idname;
}
bool_t
xdr_sfs_opt_idname (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_opt_idname *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_opt_idname *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_idnums_alloc ()
{
  return New sfs_idnums;
}
bool_t
xdr_sfs_idnums (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_idnums *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_idnums *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_idnames_alloc ()
{
  return New sfs_idnames;
}
bool_t
xdr_sfs_idnames (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_idnames *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_idnames *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_loginstat_alloc ()
{
  return New sfs_loginstat;
}
bool_t
xdr_sfs_loginstat (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_loginstat *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_loginstat *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_loginres_alloc ()
{
  return New sfs_loginres;
}
bool_t
xdr_sfs_loginres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_loginres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_loginres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_loginarg_alloc ()
{
  return New sfs_loginarg;
}
bool_t
xdr_sfs_loginarg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_loginarg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_loginarg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_stat_alloc ()
{
  return New sfsauth_stat;
}
bool_t
xdr_sfsauth_stat (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_stat *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_stat *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_authtype_alloc ()
{
  return New sfs_authtype;
}
bool_t
xdr_sfs_authtype (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_authtype *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_authtype *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_authreq_alloc ()
{
  return New sfs_authreq;
}
bool_t
xdr_sfs_authreq (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_authreq *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_authreq *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_autharg_alloc ()
{
  return New sfs_autharg;
}
bool_t
xdr_sfs_autharg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_autharg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_autharg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_credtype_alloc ()
{
  return New sfs_credtype;
}
bool_t
xdr_sfs_credtype (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_credtype *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_credtype *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_unixcred_alloc ()
{
  return New sfs_unixcred;
}
bool_t
xdr_sfs_unixcred (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_unixcred *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_unixcred *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_cred_alloc ()
{
  return New sfsauth_cred;
}
bool_t
xdr_sfsauth_cred (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_cred *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_cred *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_loginokres_alloc ()
{
  return New sfsauth_loginokres;
}
bool_t
xdr_sfsauth_loginokres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_loginokres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_loginokres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_loginres_alloc ()
{
  return New sfsauth_loginres;
}
bool_t
xdr_sfsauth_loginres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_loginres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_loginres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfssrp_parms_alloc ()
{
  return New sfssrp_parms;
}
bool_t
xdr_sfssrp_parms (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfssrp_parms *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfssrp_parms *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_srpparmsres_alloc ()
{
  return New sfsauth_srpparmsres;
}
bool_t
xdr_sfsauth_srpparmsres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_srpparmsres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_srpparmsres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfssrp_bytes_alloc ()
{
  return New sfssrp_bytes;
}
bool_t
xdr_sfssrp_bytes (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfssrp_bytes *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfssrp_bytes *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfssrp_init_arg_alloc ()
{
  return New sfssrp_init_arg;
}
bool_t
xdr_sfssrp_init_arg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfssrp_init_arg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfssrp_init_arg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_srpres_alloc ()
{
  return New sfsauth_srpres;
}
bool_t
xdr_sfsauth_srpres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_srpres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_srpres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_fetchresok_alloc ()
{
  return New sfsauth_fetchresok;
}
bool_t
xdr_sfsauth_fetchresok (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_fetchresok *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_fetchresok *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_fetchres_alloc ()
{
  return New sfsauth_fetchres;
}
bool_t
xdr_sfsauth_fetchres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_fetchres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_fetchres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_realm_alloc ()
{
  return New sfsauth_realm;
}
bool_t
xdr_sfsauth_realm (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_realm *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_realm *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_certpath_alloc ()
{
  return New sfsauth_certpath;
}
bool_t
xdr_sfsauth_certpath (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_certpath *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_certpath *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_certpaths_alloc ()
{
  return New sfsauth_certpaths;
}
bool_t
xdr_sfsauth_certpaths (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_certpaths *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_certpaths *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfs_certstat_alloc ()
{
  return New sfs_certstat;
}
bool_t
xdr_sfs_certstat (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfs_certstat *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfs_certstat *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_certinfo_info_alloc ()
{
  return New sfsauth_certinfo_info;
}
bool_t
xdr_sfsauth_certinfo_info (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_certinfo_info *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_certinfo_info *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_certinfores_alloc ()
{
  return New sfsauth_certinfores;
}
bool_t
xdr_sfsauth_certinfores (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_certinfores *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_certinfores *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_srpinfo_alloc ()
{
  return New sfsauth_srpinfo;
}
bool_t
xdr_sfsauth_srpinfo (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_srpinfo *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_srpinfo *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_registermsg_alloc ()
{
  return New sfsauth_registermsg;
}
bool_t
xdr_sfsauth_registermsg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_registermsg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_registermsg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_registerarg_alloc ()
{
  return New sfsauth_registerarg;
}
bool_t
xdr_sfsauth_registerarg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_registerarg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_registerarg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_registerres_alloc ()
{
  return New sfsauth_registerres;
}
bool_t
xdr_sfsauth_registerres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_registerres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_registerres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_updatemsg_alloc ()
{
  return New sfsauth_updatemsg;
}
bool_t
xdr_sfsauth_updatemsg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_updatemsg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_updatemsg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sfsauth_updatearg_alloc ()
{
  return New sfsauth_updatearg;
}
bool_t
xdr_sfsauth_updatearg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sfsauth_updatearg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sfsauth_updatearg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

static const rpcgen_table sfs_program_1_tbl[] = {
  SFS_PROGRAM_1_APPLY (XDRTBL_DECL)
};
const rpc_program sfs_program_1 = {
  SFS_PROGRAM, SFS_VERSION, sfs_program_1_tbl,
  sizeof (sfs_program_1_tbl) / sizeof (sfs_program_1_tbl[0]),
  "sfs_program_1"
};

static const rpcgen_table sfscb_program_1_tbl[] = {
  SFSCB_PROGRAM_1_APPLY (XDRTBL_DECL)
};
const rpc_program sfscb_program_1 = {
  SFSCB_PROGRAM, SFSCB_VERSION, sfscb_program_1_tbl,
  sizeof (sfscb_program_1_tbl) / sizeof (sfscb_program_1_tbl[0]),
  "sfscb_program_1"
};

static const rpcgen_table sfsauth_program_1_tbl[] = {
  SFSAUTH_PROGRAM_1_APPLY (XDRTBL_DECL)
};
const rpc_program sfsauth_program_1 = {
  SFSAUTH_PROGRAM, SFSAUTH_VERSION, sfsauth_program_1_tbl,
  sizeof (sfsauth_program_1_tbl) / sizeof (sfsauth_program_1_tbl[0]),
  "sfsauth_program_1"
};


